%PAKCS1.5.0

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

modulename(test).

opFixity(seq,0,right).
opFixity(==,4,non).
opFixity(+,6,left).
opFixity(-,6,left).
opFixity(*,7,left).
opFixity(div,7,left).
opFixity(mod,7,left).
opFixity(<,4,non).
opFixity(>,4,non).
opFixity(<=,4,non).
opFixity(>=,4,non).
opFixity(=:=,4,non).
opFixity(&,0,right).
opFixity(>>=,1,left).
opFixity('.',9,right).
opFixity($,0,right).
opFixity('$!',0,right).
opFixity(&&,3,right).
opFixity('||',2,right).
opFixity(/=,4,non).
opFixity(++,5,right).
opFixity('!!',9,left).
opFixity(elem,4,non).
opFixity(notElem,4,non).
opFixity(&>,0,right).
opFixity(>>,1,left).

:- block 'test.even'(?,?,-,?).
'test.even'(A,B,C,D):-hnf(A,E,C,F),'test.even_1'(E,B,F,D).

:- block 'test.even_1'(?,?,-,?).
'test.even_1'('test.zero','True',A,A).
'test.even_1'('test.succ'(A),B,C,D):-hnf(A,E,C,F),'test.even_1_test.succ_1'(E,B,F,D).

:- block 'test.even_1_test.succ_1'(?,?,-,?).
'test.even_1_test.succ_1'('test.succ'(A),B,C,D):-'test.even'(A,B,C,D).

:- block '$comp'(?,?,?,?,-,?).
'$comp'(A,B,C,D,E,F):-prelude_lambda0_1961(A,B,C,D,E,F).

:- block id(?,?,-,?).
id(A,B,C,D):-hnf(A,B,C,D).

:- block const(?,?,?,-,?).
const(A,B,C,D,E):-hnf(A,C,D,E).

:- block curry(?,?,?,?,-,?).
curry(A,B,C,D,E,F):-hnf(apply(A,'(,)'(B,C)),D,E,F).

:- block uncurry(?,?,?,-,?).
uncurry(A,B,C,D,E):-hnf(B,F,D,G),uncurry_2(F,A,C,G,E).

:- block uncurry_2(?,?,?,-,?).
uncurry_2('(,)'(A,B),C,D,E,F):-hnf(apply(apply(C,A),B),D,E,F).

:- block flip(?,?,?,?,-,?).
flip(A,B,C,D,E,F):-hnf(apply(apply(A,C),B),D,E,F).

:- block until(?,?,?,?,-,?).
until(A,B,C,D,E,F):-if_then_else(apply(share(A,G,H),share(C,I,J)),share(C,I,J),until(share(A,G,H),share(B,K,L),apply(share(B,K,L),share(C,I,J))),D,E,F).

:- block $(?,?,?,-,?).
$(A,B,C,D,E):-hnf(apply(A,B),C,D,E).

:- block '$!'(?,?,?,-,?).
'$!'(A,B,C,D,E):-hnf(seq(share(B,F,G),apply(A,share(B,F,G))),C,D,E).

:- block failed(?,-,?).
failed(A,B,C):-hnf(guardedexpr(1=:=2,D),A,B,C).

:- block &&(?,?,?,-,?).
&&(A,B,C,D,E):-hnf(A,F,D,G),'&&_1'(F,B,C,G,E).

:- block '&&_1'(?,?,?,-,?).
'&&_1'('True',A,B,C,D):-hnf(A,B,C,D).
'&&_1'('False',A,'False',B,B).

:- block '||'(?,?,?,-,?).
'||'(A,B,C,D,E):-hnf(A,F,D,G),'||_1'(F,B,C,G,E).

:- block '||_1'(?,?,?,-,?).
'||_1'('True',A,'True',B,B).
'||_1'('False',A,B,C,D):-hnf(A,B,C,D).

:- block not(?,?,-,?).
not(A,B,C,D):-hnf(A,E,C,F),not_1(E,B,F,D).

:- block not_1(?,?,-,?).
not_1('True','False',A,A).
not_1('False','True',A,A).

:- block otherwise(?,-,?).
otherwise('True',A,A).

:- block if_then_else(?,?,?,?,-,?).
if_then_else(A,B,C,D,E,F):-hnf(A,G,E,H),if_then_else_1(G,B,C,D,H,F).

:- block if_then_else_1(-,?,?,?,?,?),if_then_else_1(?,?,?,?,-,?).
if_then_else_1('True',A,B,C,D,E):-hnf(A,C,D,E).
if_then_else_1('False',A,B,C,D,E):-hnf(B,C,D,E).

:- block /=(?,?,?,-,?).
/=(A,B,C,D,E):-not(A==B,C,D,E).

:- block fst(?,?,-,?).
fst(A,B,C,D):-hnf(A,E,C,F),fst_1(E,B,F,D).

:- block fst_1(?,?,-,?).
fst_1('(,)'(A,B),C,D,E):-hnf(A,C,D,E).

:- block snd(?,?,-,?).
snd(A,B,C,D):-hnf(A,E,C,F),snd_1(E,B,F,D).

:- block snd_1(?,?,-,?).
snd_1('(,)'(A,B),C,D,E):-hnf(B,C,D,E).

:- block head(?,?,-,?).
head(A,B,C,D):-hnf(A,E,C,F),head_1(E,B,F,D).

:- block head_1(?,?,-,?).
head_1([A|B],C,D,E):-hnf(A,C,D,E).

:- block tail(?,?,-,?).
tail(A,B,C,D):-hnf(A,E,C,F),tail_1(E,B,F,D).

:- block tail_1(?,?,-,?).
tail_1([A|B],C,D,E):-hnf(B,C,D,E).

:- block null(?,?,-,?).
null(A,B,C,D):-hnf(A,E,C,F),null_1(E,B,F,D).

:- block null_1(?,?,-,?).
null_1([],'True',A,A).
null_1([A|B],'False',C,C).

:- block ++(?,?,?,-,?).
++(A,B,C,D,E):-hnf(A,F,D,G),'++_1'(F,B,C,G,E).

:- block '++_1'(?,?,?,-,?).
'++_1'([],A,B,C,D):-hnf(A,B,C,D).
'++_1'([A|B],C,[A|++(B,C)],D,D).

:- block length(?,?,-,?).
length(A,B,C,D):-hnf(A,E,C,F),length_1(E,B,F,D).

:- block length_1(?,?,-,?).
length_1([],0,A,A).
length_1([A|B],C,D,E):-hnf(1+length(B),C,D,E).

:- block '!!'(?,?,?,-,?).
'!!'(A,B,C,D,E):-hnf(A,F,D,G),'!!_1'(F,B,C,G,E).

:- block '!!_1'(?,?,?,-,?).
'!!_1'([A|B],C,D,E,F):-if_then_else(share(C,G,H)==0,A,if_then_else(share(C,G,H)>0,'!!'(B,share(C,G,H)-1),failed),D,E,F).

:- block map(?,?,?,-,?).
map(A,B,C,D,E):-hnf(B,F,D,G),map_2(F,A,C,G,E).

:- block map_2(?,?,?,-,?).
map_2([],A,[],B,B).
map_2([A|B],C,[apply(share(C,D,E),A)|map(share(C,D,E),B)],F,F).

:- block foldl(?,?,?,?,-,?).
foldl(A,B,C,D,E,F):-hnf(C,G,E,H),foldl_3(G,A,B,D,H,F).

:- block foldl_3(?,?,?,?,-,?).
foldl_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldl_3([A|B],C,D,E,F,G):-foldl(share(C,H,I),apply(apply(share(C,H,I),D),A),B,E,F,G).

:- block foldl1(?,?,?,-,?).
foldl1(A,B,C,D,E):-hnf(B,F,D,G),foldl1_2(F,A,C,G,E).

:- block foldl1_2(?,?,?,-,?).
foldl1_2([A|B],C,D,E,F):-foldl(C,A,B,D,E,F).

:- block foldr(?,?,?,?,-,?).
foldr(A,B,C,D,E,F):-hnf(C,G,E,H),foldr_3(G,A,B,D,H,F).

:- block foldr_3(?,?,?,?,-,?).
foldr_3([],A,B,C,D,E):-hnf(B,C,D,E).
foldr_3([A|B],C,D,E,F,G):-hnf(apply(apply(share(C,H,I),A),foldr(share(C,H,I),D,B)),E,F,G).

:- block foldr1(?,?,?,-,?).
foldr1(A,B,C,D,E):-hnf(B,F,D,G),foldr1_2(F,A,C,G,E).

:- block foldr1_2(?,?,?,-,?).
foldr1_2([A|B],C,D,E,F):-hnf(B,G,E,H),'foldr1_2_._2'(G,A,C,D,H,F).

:- block 'foldr1_2_._2'(?,?,?,?,-,?).
'foldr1_2_._2'([],A,B,C,D,E):-hnf(A,C,D,E).
'foldr1_2_._2'([A|B],C,D,E,F,G):-hnf(apply(apply(share(D,H,I),C),foldr1(share(D,H,I),[A|B])),E,F,G).

:- block filter(?,?,?,-,?).
filter(A,B,C,D,E):-hnf(B,F,D,G),filter_2(F,A,C,G,E).

:- block filter_2(?,?,?,-,?).
filter_2([],A,[],B,B).
filter_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),[share(A,I,J)|filter(share(C,G,H),share(B,K,L))],filter(share(C,G,H),share(B,K,L)),D,E,F).

:- block zip(?,?,?,-,?).
zip(A,B,C,D,E):-hnf(A,F,D,G),zip_1(F,B,C,G,E).

:- block zip_1(?,?,?,-,?).
zip_1([],A,[],B,B).
zip_1([A|B],C,D,E,F):-hnf(C,G,E,H),'zip_1_._3'(G,A,B,D,H,F).

:- block 'zip_1_._3'(?,?,?,?,-,?).
'zip_1_._3'([],A,B,[],C,C).
'zip_1_._3'([A|B],C,D,['(,)'(C,A)|zip(D,B)],E,E).

:- block zip3(?,?,?,?,-,?).
zip3(A,B,C,D,E,F):-hnf(A,G,E,H),zip3_1(G,B,C,D,H,F).

:- block zip3_1(?,?,?,?,-,?).
zip3_1([],A,B,[],C,C).
zip3_1([A|B],C,D,E,F,G):-hnf(C,H,F,I),'zip3_1_._3'(H,A,B,D,E,I,G).

:- block 'zip3_1_._3'(?,?,?,?,?,-,?).
'zip3_1_._3'([],A,B,C,[],D,D).
'zip3_1_._3'([A|B],C,D,E,F,G,H):-hnf(E,I,G,J),'zip3_1_._3_._5'(I,A,B,C,D,F,J,H).

:- block 'zip3_1_._3_._5'(?,?,?,?,?,?,-,?).
'zip3_1_._3_._5'([],A,B,C,D,[],E,E).
'zip3_1_._3_._5'([A|B],C,D,E,F,['(,,)'(E,C,A)|zip3(F,D,B)],G,G).

:- block zipWith(?,?,?,?,-,?).
zipWith(A,B,C,D,E,F):-hnf(B,G,E,H),zipWith_2(G,A,C,D,H,F).

:- block zipWith_2(?,?,?,?,-,?).
zipWith_2([],A,B,[],C,C).
zipWith_2([A|B],C,D,E,F,G):-hnf(D,H,F,I),'zipWith_2_._4'(H,A,B,C,E,I,G).

:- block 'zipWith_2_._4'(?,?,?,?,?,-,?).
'zipWith_2_._4'([],A,B,C,[],D,D).
'zipWith_2_._4'([A|B],C,D,E,[apply(apply(share(E,F,G),C),A)|zipWith(share(E,F,G),D,B)],H,H).

:- block zipWith3(?,?,?,?,?,-,?).
zipWith3(A,B,C,D,E,F,G):-hnf(B,H,F,I),zipWith3_2(H,A,C,D,E,I,G).

:- block zipWith3_2(?,?,?,?,?,-,?).
zipWith3_2([],A,B,C,[],D,D).
zipWith3_2([A|B],C,D,E,F,G,H):-hnf(D,I,G,J),'zipWith3_2_._4'(I,A,B,C,E,F,J,H).

:- block 'zipWith3_2_._4'(?,?,?,?,?,?,-,?).
'zipWith3_2_._4'([],A,B,C,D,[],E,E).
'zipWith3_2_._4'([A|B],C,D,E,F,G,H,I):-hnf(F,J,H,K),'zipWith3_2_._4_._6'(J,A,B,C,D,E,G,K,I).

:- block 'zipWith3_2_._4_._6'(?,?,?,?,?,?,?,-,?).
'zipWith3_2_._4_._6'([],A,B,C,D,E,[],F,F).
'zipWith3_2_._4_._6'([A|B],C,D,E,F,G,[apply(apply(apply(share(G,H,I),E),C),A)|zipWith3(share(G,H,I),F,D,B)],J,J).

:- block unzip(?,?,-,?).
unzip(A,B,C,D):-hnf(A,E,C,F),unzip_1(E,B,F,D).

:- block unzip_1(?,?,-,?).
unzip_1([],'(,)'([],[]),A,A).
unzip_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip_1_._1'(F,B,C,G,E).

:- block 'unzip_1_._1'(?,?,?,-,?).
'unzip_1_._1'('(,)'(A,B),C,D,E,F):-prelude_lambda1_1962(A,B,unzip(C),D,E,F).

:- block unzip3(?,?,-,?).
unzip3(A,B,C,D):-hnf(A,E,C,F),unzip3_1(E,B,F,D).

:- block unzip3_1(?,?,-,?).
unzip3_1([],'(,,)'([],[],[]),A,A).
unzip3_1([A|B],C,D,E):-hnf(A,F,D,G),'unzip3_1_._1'(F,B,C,G,E).

:- block 'unzip3_1_._1'(?,?,?,-,?).
'unzip3_1_._1'('(,,)'(A,B,C),D,E,F,G):-prelude_lambda2_1963(A,B,C,unzip3(D),E,F,G).

:- block concat(?,?,-,?).
concat(A,B,C,D):-foldr(++,[],A,B,C,D).

:- block concatMap(?,?,?,-,?).
concatMap(A,B,C,D,E):-hnf(apply('$comp'(concat,map(A)),B),C,D,E).

:- block iterate(?,?,?,-,?).
iterate(A,B,[share(B,C,D)|iterate(share(A,E,F),apply(share(A,E,F),share(B,C,D)))],G,G).

:- block repeat(?,?,-,?).
repeat(A,[share(A,B,C)|repeat(share(A,B,C))],D,D).

:- block replicate(?,?,?,-,?).
replicate(A,B,C,D,E):-take(A,repeat(B),C,D,E).

:- block take(?,?,?,-,?).
take(A,B,C,D,E):-if_then_else(<=(share(A,F,G),0),[],takep_418(share(A,F,G),B),C,D,E).

:- block drop(?,?,?,-,?).
drop(A,B,C,D,E):-if_then_else(<=(share(A,F,G),0),share(B,H,I),dropp_425(share(A,F,G),share(B,H,I)),C,D,E).

:- block splitAt(?,?,?,-,?).
splitAt(A,B,C,D,E):-if_then_else(<=(share(A,F,G),0),'(,)'([],share(B,H,I)),splitAtp_432(share(A,F,G),share(B,H,I)),C,D,E).

:- block takeWhile(?,?,?,-,?).
takeWhile(A,B,C,D,E):-hnf(B,F,D,G),takeWhile_2(F,A,C,G,E).

:- block takeWhile_2(?,?,?,-,?).
takeWhile_2([],A,[],B,B).
takeWhile_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),[share(A,I,J)|takeWhile(share(C,G,H),B)],[],D,E,F).

:- block dropWhile(?,?,?,-,?).
dropWhile(A,B,C,D,E):-hnf(B,F,D,G),dropWhile_2(F,A,C,G,E).

:- block dropWhile_2(?,?,?,-,?).
dropWhile_2([],A,[],B,B).
dropWhile_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),dropWhile(share(C,G,H),share(B,K,L)),[share(A,I,J)|share(B,K,L)],D,E,F).

:- block span(?,?,?,-,?).
span(A,B,C,D,E):-hnf(B,F,D,G),span_2(F,A,C,G,E).

:- block span_2(?,?,?,-,?).
span_2([],A,'(,)'([],[]),B,B).
span_2([A|B],C,D,E,F):-if_then_else(apply(share(C,G,H),share(A,I,J)),prelude_lambda4_1965(share(A,I,J),span(share(C,G,H),share(B,K,L))),'(,)'([],[share(A,I,J)|share(B,K,L)]),D,E,F).

:- block break(?,?,?,-,?).
break(A,B,C,D,E):-span('$comp'(not,A),B,C,D,E).

:- block lines(?,?,-,?).
lines(A,B,C,D):-hnf(A,E,C,F),lines_1(E,B,F,D).

:- block lines_1(?,?,-,?).
lines_1([],[],A,A).
lines_1([A|B],C,D,E):-prelude_lambda6_1967(splitline_456([A|B]),C,D,E).

:- block unlines(?,?,-,?).
unlines(A,B,C,D):-hnf(apply(concatMap(prelude_lambda7_1968),A),B,C,D).

:- block words(?,?,-,?).
words(A,B,C,D):-prelude_lambda8_1970(dropWhile(isSpace_466,A),B,C,D).

:- block unwords(?,?,-,?).
unwords(A,B,C,D):-if_then_else(share(A,E,F)==[],[],foldr1(prelude_lambda10_1971,share(A,E,F)),B,C,D).

:- block reverse(?,?,-,?).
reverse(A,B,C,D):-foldl(flip('.'),[],A,B,C,D).

:- block and(?,?,-,?).
and(A,B,C,D):-foldr(&&,'True',A,B,C,D).

:- block or(?,?,-,?).
or(A,B,C,D):-foldr('||','False',A,B,C,D).

:- block any(?,?,?,-,?).
any(A,B,C,D,E):-hnf(apply('$comp'(or,map(A)),B),C,D,E).

:- block all(?,?,?,-,?).
all(A,B,C,D,E):-hnf(apply('$comp'(and,map(A)),B),C,D,E).

:- block elem(?,?,?,-,?).
elem(A,B,C,D,E):-hnf(apply(any(prelude_lambda11_1972(A)),B),C,D,E).

:- block notElem(?,?,?,-,?).
notElem(A,B,C,D,E):-hnf(apply(all(prelude_lambda12_1973(A)),B),C,D,E).

:- block lookup(?,?,?,-,?).
lookup(A,B,C,D,E):-hnf(B,F,D,G),lookup_2(F,A,C,G,E).

:- block lookup_2(?,?,?,-,?).
lookup_2([],A,'Nothing',B,B).
lookup_2([A|B],C,D,E,F):-hnf(A,G,E,H),'lookup_2_._1'(G,B,C,D,H,F).

:- block 'lookup_2_._1'(?,?,?,?,-,?).
'lookup_2_._1'('(,)'(A,B),C,D,E,F,G):-if_then_else(share(D,H,I)==A,'Just'(B),lookup(share(D,H,I),C),E,F,G).

:- block enumFrom(?,?,-,?).
enumFrom(A,[share(A,B,C)|enumFrom(share(A,B,C)+1)],D,D).

:- block enumFromThen(?,?,?,-,?).
enumFromThen(A,B,C,D,E):-iterate(prelude_lambda13_1974(B,share(A,F,G)),share(A,F,G),C,D,E).

:- block enumFromTo(?,?,?,-,?).
enumFromTo(A,B,C,D,E):-if_then_else(share(A,F,G)>share(B,H,I),[],[share(A,F,G)|enumFromTo(share(A,F,G)+1,share(B,H,I))],C,D,E).

:- block enumFromThenTo(?,?,?,?,-,?).
enumFromThenTo(A,B,C,D,E,F):-takeWhile(p_494(share(B,G,H),share(A,I,J),C),enumFromThen(share(A,I,J),share(B,G,H)),D,E,F).

:- block &>(?,?,?,-,?).
&>(A,B,C,D,E):-hnf(guardedexpr(A,B),C,D,E).

:- block maybe(?,?,?,?,-,?).
maybe(A,B,C,D,E,F):-hnf(C,G,E,H),maybe_3(G,A,B,D,H,F).

:- block maybe_3(?,?,?,?,-,?).
maybe_3('Nothing',A,B,C,D,E):-hnf(A,C,D,E).
maybe_3('Just'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block either(?,?,?,?,-,?).
either(A,B,C,D,E,F):-hnf(C,G,E,H),either_3(G,A,B,D,H,F).

:- block either_3(?,?,?,?,-,?).
either_3('Left'(A),B,C,D,E,F):-hnf(apply(B,A),D,E,F).
either_3('Right'(A),B,C,D,E,F):-hnf(apply(C,A),D,E,F).

:- block done(?,?,-,?).
done(A,B,C,D):-hnf(apply(return('()'),A),B,C,D).

:- block putStr(?,?,?,-,?).
putStr(A,B,C,D,E):-hnf(A,F,D,G),putStr_1(F,B,C,G,E).

:- block putStr_1(-,?,?,?,?),putStr_1(?,?,?,-,?).
putStr_1([],A,B,C,D):-hnf(apply(done,A),B,C,D).
putStr_1([A|B],C,D,E,F):-hnf(apply(putChar(A)>>putStr(B),C),D,E,F).

:- block putStrLn(?,?,?,-,?).
putStrLn(A,B,C,D,E):-hnf(apply(putStr(A)>>putChar('\n'),B),C,D,E).

:- block getLine(?,?,-,?).
getLine(A,B,C,D):-hnf(apply(>>=(getChar,lambdafun_1976),A),B,C,D).

:- block print(?,?,?,-,?).
print(A,B,C,D,E):-hnf(apply(putStrLn(show(A)),B),C,D,E).

:- block doSolve(?,?,?,-,?).
doSolve(A,B,C,D,E):-hnf(guardedexpr(A,apply(done,B)),C,D,E).

:- block sequenceIO(?,?,?,-,?).
sequenceIO(A,B,C,D,E):-hnf(A,F,D,G),sequenceIO_1(F,B,C,G,E).

:- block sequenceIO_1(-,?,?,?,?),sequenceIO_1(?,?,?,-,?).
sequenceIO_1([],A,B,C,D):-hnf(apply(return([]),A),B,C,D).
sequenceIO_1([A|B],C,D,E,F):-hnf(apply(>>=(A,lambdafun_1979(B)),C),D,E,F).

:- block sequenceIO_(?,?,?,-,?).
sequenceIO_(A,B,C,D,E):-hnf(apply(foldr(>>,done,A),B),C,D,E).

:- block mapIO(?,?,?,?,-,?).
mapIO(A,B,C,D,E,F):-hnf(apply(apply('$comp'(sequenceIO,map(A)),B),C),D,E,F).

:- block mapIO_(?,?,?,?,-,?).
mapIO_(A,B,C,D,E,F):-hnf(apply(apply('$comp'(sequenceIO_,map(A)),B),C),D,E,F).

:- block inject(?,?,?,?,-,?).
inject(A,B,C,D,E,F):-prelude_lambda15_1980(B,A,C,D,E,F).

:- block solveAll(?,?,-,?).
solveAll(A,B,C,D):-evalall_529(try(A),B,C,D).

:- block solveAll2(?,?,-,?).
solveAll2(A,B,C,D):-evalResult_546(try(A),B,C,D).

:- block once(?,?,?,-,?).
once(A,B,C,D,E):-hnf(apply(head(solveAll(A)),B),C,D,E).

:- block one(?,?,-,?).
one(A,B,C,D):-solveAll(prelude_lambda16_1981(A),B,C,D).

:- block condSearch(?,?,?,-,?).
condSearch(A,B,C,D,E):-one(prelude_lambda17_1982(A,B),C,D,E).

:- block best(?,?,?,-,?).
best(A,B,C,D,E):-bestHelp_561(B,[],try(A),[],C,D,E).

:- block browse(?,?,?,-,?).
browse(A,B,C,D,E):-hnf(apply(putStr(show(unpack(A))),B),C,D,E).

:- block browseList(?,?,?,-,?).
browseList(A,B,C,D,E):-hnf(A,F,D,G),browseList_1(F,B,C,G,E).

:- block browseList_1(-,?,?,?,?),browseList_1(?,?,?,-,?).
browseList_1([],A,B,C,D):-hnf(apply(done,A),B,C,D).
browseList_1([A|B],C,D,E,F):-hnf(apply(browse(A)>>putChar('\n')>>browseList(B),C),D,E,F).

:- block unpack(?,?,-,?).
unpack(A,B,C,D):-hnf(guardedexpr(apply(A,share(E,F,G)),share(E,F,G)),B,C,D).

:- block 'PEVAL'(?,?,-,?).
'PEVAL'(A,B,C,D):-hnf(A,B,C,D).

:- block prelude_lambda0_1961(?,?,?,?,-,?).
prelude_lambda0_1961(A,B,C,D,E,F):-hnf(apply(A,apply(B,C)),D,E,F).

:- block prelude_lambda1_1962(?,?,?,?,-,?).
prelude_lambda1_1962(A,B,C,D,E,F):-hnf(C,G,E,H),prelude_lambda1_1962_3(G,A,B,D,H,F).

:- block prelude_lambda1_1962_3(?,?,?,?,-,?).
prelude_lambda1_1962_3('(,)'(A,B),C,D,'(,)'([C|A],[D|B]),E,E).

:- block prelude_lambda2_1963(?,?,?,?,?,-,?).
prelude_lambda2_1963(A,B,C,D,E,F,G):-hnf(D,H,F,I),prelude_lambda2_1963_4(H,A,B,C,E,I,G).

:- block prelude_lambda2_1963_4(?,?,?,?,?,-,?).
prelude_lambda2_1963_4('(,,)'(A,B,C),D,E,F,'(,,)'([D|A],[E|B],[F|C]),G,G).

:- block takep_418(?,?,?,-,?).
takep_418(A,B,C,D,E):-hnf(B,F,D,G),takep_418_2(F,A,C,G,E).

:- block takep_418_2(?,?,?,-,?).
takep_418_2([],A,[],B,B).
takep_418_2([A|B],C,[A|take(C-1,B)],D,D).

:- block dropp_425(?,?,?,-,?).
dropp_425(A,B,C,D,E):-hnf(B,F,D,G),dropp_425_2(F,A,C,G,E).

:- block dropp_425_2(?,?,?,-,?).
dropp_425_2([],A,[],B,B).
dropp_425_2([A|B],C,D,E,F):-drop(C-1,B,D,E,F).

:- block splitAtp_432(?,?,?,-,?).
splitAtp_432(A,B,C,D,E):-hnf(B,F,D,G),splitAtp_432_2(F,A,C,G,E).

:- block splitAtp_432_2(?,?,?,-,?).
splitAtp_432_2([],A,'(,)'([],[]),B,B).
splitAtp_432_2([A|B],C,D,E,F):-prelude_lambda3_1964(A,splitAt(C-1,B),D,E,F).

:- block prelude_lambda3_1964(?,?,?,-,?).
prelude_lambda3_1964(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda3_1964_2(F,A,C,G,E).

:- block prelude_lambda3_1964_2(?,?,?,-,?).
prelude_lambda3_1964_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda4_1965(?,?,?,-,?).
prelude_lambda4_1965(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda4_1965_2(F,A,C,G,E).

:- block prelude_lambda4_1965_2(?,?,?,-,?).
prelude_lambda4_1965_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block splitline_456(?,?,-,?).
splitline_456(A,B,C,D):-hnf(A,E,C,F),splitline_456_1(E,B,F,D).

:- block splitline_456_1(?,?,-,?).
splitline_456_1([],'(,)'([],[]),A,A).
splitline_456_1([A|B],C,D,E):-if_then_else(share(A,F,G)=='\n','(,)'([],share(B,H,I)),prelude_lambda5_1966(share(A,F,G),splitline_456(share(B,H,I))),C,D,E).

:- block prelude_lambda5_1966(?,?,?,-,?).
prelude_lambda5_1966(A,B,C,D,E):-hnf(B,F,D,G),prelude_lambda5_1966_2(F,A,C,G,E).

:- block prelude_lambda5_1966_2(?,?,?,-,?).
prelude_lambda5_1966_2('(,)'(A,B),C,'(,)'([C|A],B),D,D).

:- block prelude_lambda6_1967(?,?,-,?).
prelude_lambda6_1967(A,B,C,D):-hnf(A,E,C,F),prelude_lambda6_1967_1(E,B,F,D).

:- block prelude_lambda6_1967_1(?,?,-,?).
prelude_lambda6_1967_1('(,)'(A,B),[A|lines(B)],C,C).

:- block prelude_lambda7_1968(?,?,-,?).
prelude_lambda7_1968(A,B,C,D):- ++(A,['\n'],B,C,D).

:- block isSpace_466(?,?,-,?).
isSpace_466(A,B,C,D):-'||'(share(A,E,F)==' ','||'(share(A,E,F)=='\t','||'(share(A,E,F)=='\n',share(A,E,F)=='\r')),B,C,D).

:- block prelude_lambda9_1969(?,?,-,?).
prelude_lambda9_1969(A,B,C,D):-hnf(A,E,C,F),prelude_lambda9_1969_1(E,B,F,D).

:- block prelude_lambda9_1969_1(?,?,-,?).
prelude_lambda9_1969_1('(,)'(A,B),[A|words(B)],C,C).

:- block prelude_lambda8_1970(?,?,-,?).
prelude_lambda8_1970(A,B,C,D):-if_then_else(share(A,E,F)==[],[],prelude_lambda9_1969(apply(break(isSpace_466),share(A,E,F))),B,C,D).

:- block prelude_lambda10_1971(?,?,?,-,?).
prelude_lambda10_1971(A,B,C,D,E):- ++(A,[' '|B],C,D,E).

:- block prelude_lambda11_1972(?,?,?,-,?).
prelude_lambda11_1972(A,B,C,D,E):-hnf(A==B,C,D,E).

:- block prelude_lambda12_1973(?,?,?,-,?).
prelude_lambda12_1973(A,B,C,D,E):- /=(A,B,C,D,E).

:- block prelude_lambda13_1974(?,?,?,?,-,?).
prelude_lambda13_1974(A,B,C,D,E,F):-hnf(A-B+C,D,E,F).

:- block p_494(?,?,?,?,?,-,?).
p_494(A,B,C,D,E,F,G):-if_then_else(A>=B,<=(share(D,H,I),share(C,J,K)),share(D,H,I)>=share(C,J,K),E,F,G).

:- block prelude_lambda14_1975(?,?,?,?,-,?).
prelude_lambda14_1975(A,B,C,D,E,F):-hnf(apply(A,C),D,E,F).

:- block lambdafun_1976(?,?,?,-,?).
lambdafun_1976(A,B,C,D,E):-hnf(apply(if_then_else(share(A,F,G)=='\n',return([]),>>=(getLine,lambdafun_1977(share(A,F,G)))),B),C,D,E).

:- block lambdafun_1977(?,?,?,?,-,?).
lambdafun_1977(A,B,C,D,E,F):-hnf(apply(return([A|B]),C),D,E,F).

:- block lambdafun_1978(?,?,?,?,-,?).
lambdafun_1978(A,B,C,D,E,F):-hnf(apply(return([A|B]),C),D,E,F).

:- block lambdafun_1979(?,?,?,?,-,?).
lambdafun_1979(A,B,C,D,E,F):-hnf(apply(>>=(sequenceIO(A),lambdafun_1978(B)),C),D,E,F).

:- block prelude_lambda15_1980(?,?,?,?,-,?).
prelude_lambda15_1980(A,B,C,D,E,F):-hnf(&(apply(A,share(C,G,H)),apply(B,share(C,G,H))),D,E,F).

:- block evalall_529(?,?,-,?).
evalall_529(A,B,C,D):-hnf(A,E,C,F),evalall_529_1(E,B,F,D).

:- block evalall_529_1(?,?,-,?).
evalall_529_1([],[],A,A).
evalall_529_1([A|B],C,D,E):-hnf(B,F,D,G),'evalall_529_1_._2'(F,A,C,G,E).

:- block 'evalall_529_1_._2'(?,?,?,-,?).
'evalall_529_1_._2'([],A,[A],B,B).
'evalall_529_1_._2'([A|B],C,D,E,F):-evalall3_531(try(C),[A|B],D,E,F).

:- block evalall2_530(?,?,-,?).
evalall2_530(A,B,C,D):-hnf(A,E,C,F),evalall2_530_1(E,B,F,D).

:- block evalall2_530_1(?,?,-,?).
evalall2_530_1([],[],A,A).
evalall2_530_1([A|B],C,D,E):-evalall3_531(try(A),B,C,D,E).

:- block evalall3_531(?,?,?,-,?).
evalall3_531(A,B,C,D,E):-hnf(A,F,D,G),evalall3_531_1(F,B,C,G,E).

:- block evalall3_531_1(?,?,?,-,?).
evalall3_531_1([],A,B,C,D):-evalall2_530(A,B,C,D).
evalall3_531_1([A|B],C,D,E,F):-hnf(B,G,E,H),'evalall3_531_1_._2'(G,A,C,D,H,F).

:- block 'evalall3_531_1_._2'(?,?,?,?,-,?).
'evalall3_531_1_._2'([],A,B,[A|evalall2_530(B)],C,C).
'evalall3_531_1_._2'([A|B],C,D,E,F,G):-evalall3_531(try(C),[A|++(B,D)],E,F,G).

:- block evalResult_546(?,?,-,?).
evalResult_546(A,B,C,D):-hnf(A,E,C,F),evalResult_546_1(E,B,F,D).

:- block evalResult_546_1(?,?,-,?).
evalResult_546_1([],[],A,A).
evalResult_546_1([A|B],C,D,E):-hnf(B,F,D,G),'evalResult_546_1_._2'(F,A,C,G,E).

:- block 'evalResult_546_1_._2'(?,?,?,-,?).
'evalResult_546_1_._2'([],A,[A],B,B).
'evalResult_546_1_._2'([A|B],C,D,E,F):-hnf(apply(concatMap(solveAll2),[C,A|B]),D,E,F).

:- block prelude_lambda16_1981(?,?,?,-,?).
prelude_lambda16_1981(A,B,C,D,E):-hnf(B=:=tryone(A),C,D,E).

:- block prelude_lambda17_1982(?,?,?,?,-,?).
prelude_lambda17_1982(A,B,C,D,E,F):-hnf(&(apply(A,share(C,G,H)),apply(B,share(C,G,H))=:='True'),D,E,F).

:- block bestHelp_561(?,?,?,?,?,-,?).
bestHelp_561(A,B,C,D,E,F,G):-hnf(B,H,F,I),bestHelp_561_2(H,A,C,D,E,I,G).

:- block bestHelp_561_2(?,?,?,?,?,-,?).
bestHelp_561_2([],A,B,C,D,E,F):-hnf(B,G,E,H),'bestHelp_561_2_[]_2'(G,A,C,D,H,F).

:- block 'bestHelp_561_2_[]_2'(?,?,?,?,-,?).
'bestHelp_561_2_[]_2'([],A,B,C,D,E):-hnf(B,C,D,E).
'bestHelp_561_2_[]_2'([A|B],C,D,E,F,G):-evalB_562(share(C,H,I),try(constrain_564(share(C,H,I),A,share(D,J,K))),B,share(D,J,K),E,F,G).
bestHelp_561_2([A|B],C,D,E,F,G,H):-evalA_563(C,try(A),B,D,E,F,G,H).

:- block evalB_562(?,?,?,?,?,-,?).
evalB_562(A,B,C,D,E,F,G):-hnf(B,H,F,I),evalB_562_2(H,A,C,D,E,I,G).

:- block evalB_562_2(?,?,?,?,?,-,?).
evalB_562_2([],A,B,C,D,E,F):-bestHelp_561(A,[],B,C,D,E,F).
evalB_562_2([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'evalB_562_2_._2'(I,A,C,D,E,F,J,H).

:- block 'evalB_562_2_._2'(?,?,?,?,?,?,-,?).
'evalB_562_2_._2'([],A,B,C,D,E,F,G):-bestHelp_561(B,[],C,[A],E,F,G).
'evalB_562_2_._2'([A|B],C,D,E,F,G,H,I):-bestHelp_561(D,[C,A|B],E,F,G,H,I).

:- block evalA_563(?,?,?,?,?,?,-,?).
evalA_563(A,B,C,D,E,F,G,H):-hnf(B,I,G,J),evalA_563_2(I,A,C,D,E,F,J,H).

:- block evalA_563_2(?,?,?,?,?,?,-,?).
evalA_563_2([],A,B,C,D,E,F,G):-bestHelp_561(A,B,C,D,E,F,G).
evalA_563_2([A|B],C,D,E,F,G,H,I):-hnf(B,J,H,K),'evalA_563_2_._2'(J,A,C,D,E,F,G,K,I).

:- block 'evalA_563_2_._2'(?,?,?,?,?,?,?,-,?).
'evalA_563_2_._2'([],A,B,C,D,E,F,G,H):-bestHelp_561(B,[],++(C,D),[A],F,G,H).
'evalA_563_2_._2'([A|B],C,D,E,F,G,H,I,J):-bestHelp_561(D,++([C,A|B],E),F,G,H,I,J).

:- block constrain_564(?,?,?,?,?,-,?).
constrain_564(A,B,C,D,E,F,G):-hnf(C,H,F,I),constrain_564_3(H,A,B,D,E,I,G).

:- block constrain_564_3(?,?,?,?,?,-,?).
constrain_564_3([],A,B,C,D,E,F):-hnf(apply(B,C),D,E,F).
constrain_564_3([A|B],C,D,E,F,G,H):-hnf(B,I,G,J),'constrain_564_3_._2'(I,A,C,D,E,F,J,H).

:- block 'constrain_564_3_._2'(?,?,?,?,?,?,-,?).
'constrain_564_3_._2'([],A,B,C,D,E,F,G):-hnf(apply(inject(C,prelude_lambda18_1983(A,B)),D),E,F,G).

:- block prelude_lambda18_1983(?,?,?,?,-,?).
prelude_lambda18_1983(A,B,C,D,E,F):-hnf(&(apply(A,share(G,H,I)),apply(apply(B,C),share(G,H,I))=:='True'),D,E,F).

:-block hnf(?,?,-,?).
hnf(A,B,C,C):-var(A),!,B=A.
hnf(share(A,B,C),D,E,F):-!,(nonvar(B)->C=D,E=F;hnf(A,G,E,F),(nonvar(G),(functor(G,'$io',1);functor(G,success,0))->D=G;propagateShare(G,D),B=eval,C=D)).
hnf('test.even'(A),B,C,D):-!,'test.even'(A,B,C,D).
hnf('$comp'(A,B,C),D,E,F):-!,'$comp'(A,B,C,D,E,F).
hnf(id(A),B,C,D):-!,id(A,B,C,D).
hnf(const(A,B),C,D,E):-!,const(A,B,C,D,E).
hnf(curry(A,B,C),D,E,F):-!,curry(A,B,C,D,E,F).
hnf(uncurry(A,B),C,D,E):-!,uncurry(A,B,C,D,E).
hnf(flip(A,B,C),D,E,F):-!,flip(A,B,C,D,E,F).
hnf(until(A,B,C),D,E,F):-!,until(A,B,C,D,E,F).
hnf($(A,B),C,D,E):-!,$(A,B,C,D,E).
hnf('$!'(A,B),C,D,E):-!,'$!'(A,B,C,D,E).
hnf(failed,A,B,C):-!,failed(A,B,C).
hnf(&&(A,B),C,D,E):-!,&&(A,B,C,D,E).
hnf('||'(A,B),C,D,E):-!,'||'(A,B,C,D,E).
hnf(not(A),B,C,D):-!,not(A,B,C,D).
hnf(otherwise,A,B,C):-!,otherwise(A,B,C).
hnf(if_then_else(A,B,C),D,E,F):-!,if_then_else(A,B,C,D,E,F).
hnf(/=(A,B),C,D,E):-!,/=(A,B,C,D,E).
hnf(fst(A),B,C,D):-!,fst(A,B,C,D).
hnf(snd(A),B,C,D):-!,snd(A,B,C,D).
hnf(head(A),B,C,D):-!,head(A,B,C,D).
hnf(tail(A),B,C,D):-!,tail(A,B,C,D).
hnf(null(A),B,C,D):-!,null(A,B,C,D).
hnf(++(A,B),C,D,E):-!,++(A,B,C,D,E).
hnf(length(A),B,C,D):-!,length(A,B,C,D).
hnf('!!'(A,B),C,D,E):-!,'!!'(A,B,C,D,E).
hnf(map(A,B),C,D,E):-!,map(A,B,C,D,E).
hnf(foldl(A,B,C),D,E,F):-!,foldl(A,B,C,D,E,F).
hnf(foldl1(A,B),C,D,E):-!,foldl1(A,B,C,D,E).
hnf(foldr(A,B,C),D,E,F):-!,foldr(A,B,C,D,E,F).
hnf(foldr1(A,B),C,D,E):-!,foldr1(A,B,C,D,E).
hnf(filter(A,B),C,D,E):-!,filter(A,B,C,D,E).
hnf(zip(A,B),C,D,E):-!,zip(A,B,C,D,E).
hnf(zip3(A,B,C),D,E,F):-!,zip3(A,B,C,D,E,F).
hnf(zipWith(A,B,C),D,E,F):-!,zipWith(A,B,C,D,E,F).
hnf(zipWith3(A,B,C,D),E,F,G):-!,zipWith3(A,B,C,D,E,F,G).
hnf(unzip(A),B,C,D):-!,unzip(A,B,C,D).
hnf(unzip3(A),B,C,D):-!,unzip3(A,B,C,D).
hnf(concat(A),B,C,D):-!,concat(A,B,C,D).
hnf(concatMap(A,B),C,D,E):-!,concatMap(A,B,C,D,E).
hnf(iterate(A,B),C,D,E):-!,iterate(A,B,C,D,E).
hnf(repeat(A),B,C,D):-!,repeat(A,B,C,D).
hnf(replicate(A,B),C,D,E):-!,replicate(A,B,C,D,E).
hnf(take(A,B),C,D,E):-!,take(A,B,C,D,E).
hnf(drop(A,B),C,D,E):-!,drop(A,B,C,D,E).
hnf(splitAt(A,B),C,D,E):-!,splitAt(A,B,C,D,E).
hnf(takeWhile(A,B),C,D,E):-!,takeWhile(A,B,C,D,E).
hnf(dropWhile(A,B),C,D,E):-!,dropWhile(A,B,C,D,E).
hnf(span(A,B),C,D,E):-!,span(A,B,C,D,E).
hnf(break(A,B),C,D,E):-!,break(A,B,C,D,E).
hnf(lines(A),B,C,D):-!,lines(A,B,C,D).
hnf(unlines(A),B,C,D):-!,unlines(A,B,C,D).
hnf(words(A),B,C,D):-!,words(A,B,C,D).
hnf(unwords(A),B,C,D):-!,unwords(A,B,C,D).
hnf(reverse(A),B,C,D):-!,reverse(A,B,C,D).
hnf(and(A),B,C,D):-!,and(A,B,C,D).
hnf(or(A),B,C,D):-!,or(A,B,C,D).
hnf(any(A,B),C,D,E):-!,any(A,B,C,D,E).
hnf(all(A,B),C,D,E):-!,all(A,B,C,D,E).
hnf(elem(A,B),C,D,E):-!,elem(A,B,C,D,E).
hnf(notElem(A,B),C,D,E):-!,notElem(A,B,C,D,E).
hnf(lookup(A,B),C,D,E):-!,lookup(A,B,C,D,E).
hnf(enumFrom(A),B,C,D):-!,enumFrom(A,B,C,D).
hnf(enumFromThen(A,B),C,D,E):-!,enumFromThen(A,B,C,D,E).
hnf(enumFromTo(A,B),C,D,E):-!,enumFromTo(A,B,C,D,E).
hnf(enumFromThenTo(A,B,C),D,E,F):-!,enumFromThenTo(A,B,C,D,E,F).
hnf(&>(A,B),C,D,E):-!,&>(A,B,C,D,E).
hnf(maybe(A,B,C),D,E,F):-!,maybe(A,B,C,D,E,F).
hnf(either(A,B,C),D,E,F):-!,either(A,B,C,D,E,F).
hnf(done(A),B,C,D):-!,done(A,B,C,D).
hnf(putStr(A,B),C,D,E):-!,putStr(A,B,C,D,E).
hnf(putStrLn(A,B),C,D,E):-!,putStrLn(A,B,C,D,E).
hnf(getLine(A),B,C,D):-!,getLine(A,B,C,D).
hnf(print(A,B),C,D,E):-!,print(A,B,C,D,E).
hnf(doSolve(A,B),C,D,E):-!,doSolve(A,B,C,D,E).
hnf(sequenceIO(A,B),C,D,E):-!,sequenceIO(A,B,C,D,E).
hnf(sequenceIO_(A,B),C,D,E):-!,sequenceIO_(A,B,C,D,E).
hnf(mapIO(A,B,C),D,E,F):-!,mapIO(A,B,C,D,E,F).
hnf(mapIO_(A,B,C),D,E,F):-!,mapIO_(A,B,C,D,E,F).
hnf(inject(A,B,C),D,E,F):-!,inject(A,B,C,D,E,F).
hnf(solveAll(A),B,C,D):-!,solveAll(A,B,C,D).
hnf(solveAll2(A),B,C,D):-!,solveAll2(A,B,C,D).
hnf(once(A,B),C,D,E):-!,once(A,B,C,D,E).
hnf(one(A),B,C,D):-!,one(A,B,C,D).
hnf(condSearch(A,B),C,D,E):-!,condSearch(A,B,C,D,E).
hnf(best(A,B),C,D,E):-!,best(A,B,C,D,E).
hnf(browse(A,B),C,D,E):-!,browse(A,B,C,D,E).
hnf(browseList(A,B),C,D,E):-!,browseList(A,B,C,D,E).
hnf(unpack(A),B,C,D):-!,unpack(A,B,C,D).
hnf('PEVAL'(A),B,C,D):-!,'PEVAL'(A,B,C,D).
hnf(prelude_lambda0_1961(A,B,C),D,E,F):-!,prelude_lambda0_1961(A,B,C,D,E,F).
hnf(prelude_lambda1_1962(A,B,C),D,E,F):-!,prelude_lambda1_1962(A,B,C,D,E,F).
hnf(prelude_lambda2_1963(A,B,C,D),E,F,G):-!,prelude_lambda2_1963(A,B,C,D,E,F,G).
hnf(takep_418(A,B),C,D,E):-!,takep_418(A,B,C,D,E).
hnf(dropp_425(A,B),C,D,E):-!,dropp_425(A,B,C,D,E).
hnf(splitAtp_432(A,B),C,D,E):-!,splitAtp_432(A,B,C,D,E).
hnf(prelude_lambda3_1964(A,B),C,D,E):-!,prelude_lambda3_1964(A,B,C,D,E).
hnf(prelude_lambda4_1965(A,B),C,D,E):-!,prelude_lambda4_1965(A,B,C,D,E).
hnf(splitline_456(A),B,C,D):-!,splitline_456(A,B,C,D).
hnf(prelude_lambda5_1966(A,B),C,D,E):-!,prelude_lambda5_1966(A,B,C,D,E).
hnf(prelude_lambda6_1967(A),B,C,D):-!,prelude_lambda6_1967(A,B,C,D).
hnf(prelude_lambda7_1968(A),B,C,D):-!,prelude_lambda7_1968(A,B,C,D).
hnf(isSpace_466(A),B,C,D):-!,isSpace_466(A,B,C,D).
hnf(prelude_lambda9_1969(A),B,C,D):-!,prelude_lambda9_1969(A,B,C,D).
hnf(prelude_lambda8_1970(A),B,C,D):-!,prelude_lambda8_1970(A,B,C,D).
hnf(prelude_lambda10_1971(A,B),C,D,E):-!,prelude_lambda10_1971(A,B,C,D,E).
hnf(prelude_lambda11_1972(A,B),C,D,E):-!,prelude_lambda11_1972(A,B,C,D,E).
hnf(prelude_lambda12_1973(A,B),C,D,E):-!,prelude_lambda12_1973(A,B,C,D,E).
hnf(prelude_lambda13_1974(A,B,C),D,E,F):-!,prelude_lambda13_1974(A,B,C,D,E,F).
hnf(p_494(A,B,C,D),E,F,G):-!,p_494(A,B,C,D,E,F,G).
hnf(prelude_lambda14_1975(A,B,C),D,E,F):-!,prelude_lambda14_1975(A,B,C,D,E,F).
hnf(lambdafun_1976(A,B),C,D,E):-!,lambdafun_1976(A,B,C,D,E).
hnf(lambdafun_1977(A,B,C),D,E,F):-!,lambdafun_1977(A,B,C,D,E,F).
hnf(lambdafun_1978(A,B,C),D,E,F):-!,lambdafun_1978(A,B,C,D,E,F).
hnf(lambdafun_1979(A,B,C),D,E,F):-!,lambdafun_1979(A,B,C,D,E,F).
hnf(prelude_lambda15_1980(A,B,C),D,E,F):-!,prelude_lambda15_1980(A,B,C,D,E,F).
hnf(evalall_529(A),B,C,D):-!,evalall_529(A,B,C,D).
hnf(evalall2_530(A),B,C,D):-!,evalall2_530(A,B,C,D).
hnf(evalall3_531(A,B),C,D,E):-!,evalall3_531(A,B,C,D,E).
hnf(evalResult_546(A),B,C,D):-!,evalResult_546(A,B,C,D).
hnf(prelude_lambda16_1981(A,B),C,D,E):-!,prelude_lambda16_1981(A,B,C,D,E).
hnf(prelude_lambda17_1982(A,B,C),D,E,F):-!,prelude_lambda17_1982(A,B,C,D,E,F).
hnf(bestHelp_561(A,B,C,D),E,F,G):-!,bestHelp_561(A,B,C,D,E,F,G).
hnf(evalB_562(A,B,C,D),E,F,G):-!,evalB_562(A,B,C,D,E,F,G).
hnf(evalA_563(A,B,C,D,E),F,G,H):-!,evalA_563(A,B,C,D,E,F,G,H).
hnf(constrain_564(A,B,C,D),E,F,G):-!,constrain_564(A,B,C,D,E,F,G).
hnf(prelude_lambda18_1983(A,B,C),D,E,F):-!,prelude_lambda18_1983(A,B,C,D,E,F).
hnf(A+B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_+'(F,H,C,I,E).
hnf(A-B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_-'(F,H,C,I,E).
hnf(A*B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_*'(F,H,C,I,E).
hnf(div(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_div(F,H,C,I,E).
hnf(A mod B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),prim_mod(F,H,C,I,E).
hnf(A<B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<'(F,H,C,I,E).
hnf(A>B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>'(F,H,C,I,E).
hnf(<=(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_<='(F,H,C,I,E).
hnf(A>=B,C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_>='(F,H,C,I,E).
hnf(ord(A),B,C,D):-!,hnf(A,E,C,F),prim_ord(E,B,F,D).
hnf(chr(A),B,C,D):-!,hnf(A,E,C,F),prim_chr(E,B,F,D).
hnf(>>=(A,B,C),D,E,F):-!,hnf(A,G,E,H),'prim_>>='(G,B,C,D,H,F).
hnf(>>(A,B,C),D,E,F):-!,hnf(A,G,E,H),'prim_>>'(G,B,C,D,H,F).
hnf(putChar(A,B),C,D,E):-!,hnf(A,F,D,G),prim_putChar(F,B,C,G,E).
hnf(getChar(A),B,C,D):-!,prim_getChar(A,B,C,D).
hnf(return(A,B),C,D,E):-!,prim_return(A,B,C,D,E).
hnf(readFile(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),prim_readFile(F,B,C,I,E).
hnf('#readFileContents'(A,B),C,D,E):-!,'prim_#readFileContents'(A,B,C,D,E).
hnf(writeFile(A,B,C),D,E,F):-!,nf(A,G,E,H),seq(G,G,I,H,J),prim_writeFile(G,B,C,D,J,F).
hnf(appendFile(A,B,C),D,E,F):-!,nf(A,G,E,H),seq(G,G,I,H,J),prim_appendFile(G,B,C,D,J,F).
hnf('#writeFileContents'(A,B,C),D,E,F):-!,hnf(B,G,E,H),'prim_#writeFileContents'(A,G,C,D,H,F).
hnf(catchFail(A,B,C),D,E,F):-!,prim_catchFail(A,B,C,D,E,F).
hnf(findall(A),B,C,D):-!,hnf(A,E,C,F),prim_findall(E,B,F,D).
hnf(findfirst(A),B,C,D):-!,hnf(A,E,C,F),prim_findfirst(E,B,F,D).
hnf(show(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_show(E,B,H,D).
hnf(seq(A,B),C,D,E):-!,hnf(A,F,D,G),prim_seq(F,B,C,G,E).
hnf(error(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),prim_error(E,B,H,D).
hnf('Unsafe.unsafePerformIO'(A),B,C,D):-!,hnf(A,E,C,F),'prim_Unsafe.unsafePerformIO'(E,B,F,D).
hnf('ACurry.readCurryFile'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_ACurry.readCurryFile'(F,B,C,I,E).
hnf('Flat.readFlatCurryFile'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Flat.readFlatCurryFile'(F,B,C,I,E).
hnf('System.getCPUTime'(A),B,C,D):-!,'prim_System.getCPUTime'(A,B,C,D).
hnf('System.getElapsedTime'(A),B,C,D):-!,'prim_System.getElapsedTime'(A,B,C,D).
hnf('System.getDate'(A),B,C,D):-!,'prim_System.getDate'(A,B,C,D).
hnf('System.getArgs'(A),B,C,D):-!,'prim_System.getArgs'(A,B,C,D).
hnf('System.getEnviron'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_System.getEnviron'(F,B,C,I,E).
hnf('System.getHostname'(A),B,C,D):-!,'prim_System.getHostname'(A,B,C,D).
hnf('System.getPID'(A),B,C,D):-!,'prim_System.getPID'(A,B,C,D).
hnf('System.system'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_System.system'(F,B,C,I,E).
hnf('System.sleep'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_System.sleep'(F,B,C,I,E).
hnf('System.evalTime'(A),B,C,D):-!,'prim_System.evalTime'(A,B,C,D).
hnf('System.evalSpace'(A),B,C,D):-!,'prim_System.evalSpace'(A,B,C,D).
hnf('Time.getClockTime'(A),B,C,D):-!,'prim_Time.getClockTime'(A,B,C,D).
hnf('Directory.doesFileExist'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Directory.doesFileExist'(F,B,C,I,E).
hnf('Directory.doesDirectoryExist'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Directory.doesDirectoryExist'(F,B,C,I,E).
hnf('Directory.getModificationTime'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Directory.getModificationTime'(F,B,C,I,E).
hnf('Directory.getDirectoryContents'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Directory.getDirectoryContents'(F,B,C,I,E).
hnf('Term.showTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),'prim_Term.showTerm'(E,B,H,D).
hnf('Term.readTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),'prim_Term.readTerm'(E,B,H,D).
hnf('Term.encodeTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),'prim_Term.encodeTerm'(E,B,H,D).
hnf('Term.decodeTerm'(A),B,C,D):-!,nf(A,E,C,F),seq(E,E,G,F,H),'prim_Term.decodeTerm'(E,B,H,D).
hnf('Ports.openPort'(A,B),C,D,E):-!,nf(A,F,D,G),nf(B,H,G,I),'prim_Ports.openPort'(F,H,C,I,E).
hnf('#basicserverloop'(A,B),C,D,E):-!,'prim_#basicserverloop'(A,B,C,D,E).
hnf('Ports.send'(A,B),C,D,E):-!,nf(A,F,D,G),hnf(B,H,G,I),'prim_Ports.send'(F,H,C,I,E).
hnf('Ports.openProcessPort'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Ports.openProcessPort'(F,B,C,I,E).
hnf('Ports.openSocketConnectPort'(A,B,C),D,E,F):-!,nf(A,G,E,H),seq(G,G,I,H,J),nf(B,K,J,L),seq(K,K,M,L,N),'prim_Ports.openSocketConnectPort'(G,K,C,D,N,F).
hnf('Ports.ping'(A,B,C),D,E,F):-!,nf(A,G,E,H),seq(G,G,I,H,J),hnf(B,K,J,L),'prim_Ports.ping'(G,K,C,D,L,F).
hnf('Ports.timeoutOnStream'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_Ports.timeoutOnStream'(F,B,C,I,E).
hnf('Ports.openPortOnSocket'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_Ports.openPortOnSocket'(G,I,C,D,J,F).
hnf('Ports.connectPortAtSocket'(A,B,C,D),E,F,G):-!,nf(A,H,F,I),seq(H,H,J,I,K),nf(B,L,K,M),seq(L,L,N,M,O),nf(C,P,O,Q),seq(P,P,R,Q,S),'prim_Ports.connectPortAtSocket'(H,L,P,D,E,S,G).
hnf('Ports.choiceSPEP'(A,B),C,D,E):-!,hnf(A,F,D,G),'prim_Ports.choiceSPEP'(F,B,C,G,E).
hnf('CLPR.+.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.+.'(F,H,C,I,E).
hnf('CLPR.-.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.-.'(F,H,C,I,E).
hnf('CLPR.*.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.*.'(F,H,C,I,E).
hnf('CLPR./.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR./.'(F,H,C,I,E).
hnf('CLPR.<.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.<.'(F,H,C,I,E).
hnf('CLPR.>.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.>.'(F,H,C,I,E).
hnf('CLPR.<=.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.<=.'(F,H,C,I,E).
hnf('CLPR.>=.'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPR.>=.'(F,H,C,I,E).
hnf('CLPR.i2f'(A),B,C,D):-!,hnf(A,E,C,F),'prim_CLPR.i2f'(E,B,F,D).
hnf('CLPFD.+#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.+#'(F,H,C,I,E).
hnf('CLPFD.-#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.-#'(F,H,C,I,E).
hnf('CLPFD.*#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.*#'(F,H,C,I,E).
hnf('CLPFD.=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.=#'(F,H,C,I,E).
hnf('CLPFD./=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD./=#'(F,H,C,I,E).
hnf('CLPFD.<#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.<#'(F,H,C,I,E).
hnf('CLPFD.>#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.>#'(F,H,C,I,E).
hnf('CLPFD.<=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.<=#'(F,H,C,I,E).
hnf('CLPFD.>=#'(A,B),C,D,E):-!,hnf(A,F,D,G),hnf(B,H,G,I),'prim_CLPFD.>=#'(F,H,C,I,E).
hnf('CLPFD.domain'(A,B,C),D,E,F):-!,nf(A,G,E,H),hnf(B,I,H,J),hnf(C,K,J,L),'prim_CLPFD.domain'(G,I,K,D,L,F).
hnf('CLPFD.all_different'(A),B,C,D):-!,nf(A,E,C,F),'prim_CLPFD.all_different'(E,B,F,D).
hnf('CLPFD.labeling'(A),B,C,D):-!,nf(A,E,C,F),'prim_CLPFD.labeling'(E,B,F,D).
hnf('TermDB.openDB'(A,B),C,D,E):-!,nf(A,F,D,G),seq(F,F,H,G,I),'prim_TermDB.openDB'(F,B,C,I,E).
hnf('TermDB.closeDB'(A,B),C,D,E):-!,nf(A,F,D,G),'prim_TermDB.closeDB'(F,B,C,G,E).
hnf('TermDB.storeDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),seq(G,G,I,H,J),nf(B,K,J,L),'prim_TermDB.storeDB'(G,K,C,D,L,F).
hnf('TermDB.eraseDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_TermDB.eraseDB'(G,I,C,D,J,F).
hnf('TermDB.findallDB'(A,B,C),D,E,F):-!,nf(A,G,E,H),nf(B,I,H,J),'prim_TermDB.findallDB'(G,I,C,D,J,F).
hnf(try(A),B,C,D):-!,write('*** '),write(try(A)),write(' currently not supported!'),nl.
hnf(comittedChoice(A),B,C,D):-!,write('*** '),write(comittedChoice(A)),write(' currently not supported!'),nl.
hnf(browse(A),B,C,D):-!,write('*** '),write(browse(A)),write(' currently not supported!'),nl.
hnf(tryone(A),B,C,D):-!,write('*** '),write(tryone(A)),write(' currently not supported!'),nl.
hnf(A=:=B,success,C,D):-!,eq(A,B,C,D).
hnf(A==B,C,D,E):-!,seq(A,B,C,D,E).
hnf(&(A,B),success,C,D):-!,hnf(A,E,C,F),hnf(B,G,C,H),waitconj(E,G,F,H,D).
hnf(apply(A,B),C,D,E):-!,hnf(A,F,D,G),apply(F,B,C,G,E).
hnf(guardedexpr(A,B),C,D,E):-!,hnf(A,F,D,G),F=success,hnf(B,C,G,E).
hnf(A,A,B,B).

:-block apply(-,?,?,?,?),apply(?,?,?,-,?).
apply('test.even',A,B,C,D):-hnf('test.even'(A),B,C,D).
apply(==,A,==(A),B,B).
apply(==(A),B,C,D,E):-hnf(A==B,C,D,E).
apply(=:=,A,=:=(A),B,B).
apply(=:=(A),B,C,D,E):-hnf(A=:=B,C,D,E).
apply('$comp',A,'$comp'(A),B,B).
apply('$comp'(A),B,'$comp'(A,B),C,C).
apply('$comp'(A,B),C,D,E,F):-hnf('$comp'(A,B,C),D,E,F).
apply(id,A,B,C,D):-hnf(id(A),B,C,D).
apply(const,A,const(A),B,B).
apply(const(A),B,C,D,E):-hnf(const(A,B),C,D,E).
apply(curry,A,curry(A),B,B).
apply(curry(A),B,curry(A,B),C,C).
apply(curry(A,B),C,D,E,F):-hnf(curry(A,B,C),D,E,F).
apply(uncurry,A,uncurry(A),B,B).
apply(uncurry(A),B,C,D,E):-hnf(uncurry(A,B),C,D,E).
apply(flip,A,flip(A),B,B).
apply(flip(A),B,flip(A,B),C,C).
apply(flip(A,B),C,D,E,F):-hnf(flip(A,B,C),D,E,F).
apply(until,A,until(A),B,B).
apply(until(A),B,until(A,B),C,C).
apply(until(A,B),C,D,E,F):-hnf(until(A,B,C),D,E,F).
apply($,A,$(A),B,B).
apply($(A),B,C,D,E):-hnf($(A,B),C,D,E).
apply('$!',A,'$!'(A),B,B).
apply('$!'(A),B,C,D,E):-hnf('$!'(A,B),C,D,E).
apply(&&,A,&&(A),B,B).
apply(&&(A),B,C,D,E):-hnf(&&(A,B),C,D,E).
apply('||',A,'||'(A),B,B).
apply('||'(A),B,C,D,E):-hnf('||'(A,B),C,D,E).
apply(not,A,B,C,D):-hnf(not(A),B,C,D).
apply(if_then_else,A,if_then_else(A),B,B).
apply(if_then_else(A),B,if_then_else(A,B),C,C).
apply(if_then_else(A,B),C,D,E,F):-hnf(if_then_else(A,B,C),D,E,F).
apply(/=,A,/=(A),B,B).
apply(/=(A),B,C,D,E):-hnf(/=(A,B),C,D,E).
apply(fst,A,B,C,D):-hnf(fst(A),B,C,D).
apply(snd,A,B,C,D):-hnf(snd(A),B,C,D).
apply(head,A,B,C,D):-hnf(head(A),B,C,D).
apply(tail,A,B,C,D):-hnf(tail(A),B,C,D).
apply(null,A,B,C,D):-hnf(null(A),B,C,D).
apply(++,A,++(A),B,B).
apply(++(A),B,C,D,E):-hnf(++(A,B),C,D,E).
apply(length,A,B,C,D):-hnf(length(A),B,C,D).
apply('!!',A,'!!'(A),B,B).
apply('!!'(A),B,C,D,E):-hnf('!!'(A,B),C,D,E).
apply(map,A,map(A),B,B).
apply(map(A),B,C,D,E):-hnf(map(A,B),C,D,E).
apply(foldl,A,foldl(A),B,B).
apply(foldl(A),B,foldl(A,B),C,C).
apply(foldl(A,B),C,D,E,F):-hnf(foldl(A,B,C),D,E,F).
apply(foldl1,A,foldl1(A),B,B).
apply(foldl1(A),B,C,D,E):-hnf(foldl1(A,B),C,D,E).
apply(foldr,A,foldr(A),B,B).
apply(foldr(A),B,foldr(A,B),C,C).
apply(foldr(A,B),C,D,E,F):-hnf(foldr(A,B,C),D,E,F).
apply(foldr1,A,foldr1(A),B,B).
apply(foldr1(A),B,C,D,E):-hnf(foldr1(A,B),C,D,E).
apply(filter,A,filter(A),B,B).
apply(filter(A),B,C,D,E):-hnf(filter(A,B),C,D,E).
apply(zip,A,zip(A),B,B).
apply(zip(A),B,C,D,E):-hnf(zip(A,B),C,D,E).
apply(zip3,A,zip3(A),B,B).
apply(zip3(A),B,zip3(A,B),C,C).
apply(zip3(A,B),C,D,E,F):-hnf(zip3(A,B,C),D,E,F).
apply(zipWith,A,zipWith(A),B,B).
apply(zipWith(A),B,zipWith(A,B),C,C).
apply(zipWith(A,B),C,D,E,F):-hnf(zipWith(A,B,C),D,E,F).
apply(zipWith3,A,zipWith3(A),B,B).
apply(zipWith3(A),B,zipWith3(A,B),C,C).
apply(zipWith3(A,B),C,zipWith3(A,B,C),D,D).
apply(zipWith3(A,B,C),D,E,F,G):-hnf(zipWith3(A,B,C,D),E,F,G).
apply(unzip,A,B,C,D):-hnf(unzip(A),B,C,D).
apply(unzip3,A,B,C,D):-hnf(unzip3(A),B,C,D).
apply(concat,A,B,C,D):-hnf(concat(A),B,C,D).
apply(concatMap,A,concatMap(A),B,B).
apply(concatMap(A),B,C,D,E):-hnf(concatMap(A,B),C,D,E).
apply(iterate,A,iterate(A),B,B).
apply(iterate(A),B,C,D,E):-hnf(iterate(A,B),C,D,E).
apply(repeat,A,B,C,D):-hnf(repeat(A),B,C,D).
apply(replicate,A,replicate(A),B,B).
apply(replicate(A),B,C,D,E):-hnf(replicate(A,B),C,D,E).
apply(take,A,take(A),B,B).
apply(take(A),B,C,D,E):-hnf(take(A,B),C,D,E).
apply(drop,A,drop(A),B,B).
apply(drop(A),B,C,D,E):-hnf(drop(A,B),C,D,E).
apply(splitAt,A,splitAt(A),B,B).
apply(splitAt(A),B,C,D,E):-hnf(splitAt(A,B),C,D,E).
apply(takeWhile,A,takeWhile(A),B,B).
apply(takeWhile(A),B,C,D,E):-hnf(takeWhile(A,B),C,D,E).
apply(dropWhile,A,dropWhile(A),B,B).
apply(dropWhile(A),B,C,D,E):-hnf(dropWhile(A,B),C,D,E).
apply(span,A,span(A),B,B).
apply(span(A),B,C,D,E):-hnf(span(A,B),C,D,E).
apply(break,A,break(A),B,B).
apply(break(A),B,C,D,E):-hnf(break(A,B),C,D,E).
apply(lines,A,B,C,D):-hnf(lines(A),B,C,D).
apply(unlines,A,B,C,D):-hnf(unlines(A),B,C,D).
apply(words,A,B,C,D):-hnf(words(A),B,C,D).
apply(unwords,A,B,C,D):-hnf(unwords(A),B,C,D).
apply(reverse,A,B,C,D):-hnf(reverse(A),B,C,D).
apply(and,A,B,C,D):-hnf(and(A),B,C,D).
apply(or,A,B,C,D):-hnf(or(A),B,C,D).
apply(any,A,any(A),B,B).
apply(any(A),B,C,D,E):-hnf(any(A,B),C,D,E).
apply(all,A,all(A),B,B).
apply(all(A),B,C,D,E):-hnf(all(A,B),C,D,E).
apply(elem,A,elem(A),B,B).
apply(elem(A),B,C,D,E):-hnf(elem(A,B),C,D,E).
apply(notElem,A,notElem(A),B,B).
apply(notElem(A),B,C,D,E):-hnf(notElem(A,B),C,D,E).
apply(lookup,A,lookup(A),B,B).
apply(lookup(A),B,C,D,E):-hnf(lookup(A,B),C,D,E).
apply(enumFrom,A,B,C,D):-hnf(enumFrom(A),B,C,D).
apply(enumFromThen,A,enumFromThen(A),B,B).
apply(enumFromThen(A),B,C,D,E):-hnf(enumFromThen(A,B),C,D,E).
apply(enumFromTo,A,enumFromTo(A),B,B).
apply(enumFromTo(A),B,C,D,E):-hnf(enumFromTo(A,B),C,D,E).
apply(enumFromThenTo,A,enumFromThenTo(A),B,B).
apply(enumFromThenTo(A),B,enumFromThenTo(A,B),C,C).
apply(enumFromThenTo(A,B),C,D,E,F):-hnf(enumFromThenTo(A,B,C),D,E,F).
apply(&>,A,&>(A),B,B).
apply(&>(A),B,C,D,E):-hnf(&>(A,B),C,D,E).
apply(maybe,A,maybe(A),B,B).
apply(maybe(A),B,maybe(A,B),C,C).
apply(maybe(A,B),C,D,E,F):-hnf(maybe(A,B,C),D,E,F).
apply(either,A,either(A),B,B).
apply(either(A),B,either(A,B),C,C).
apply(either(A,B),C,D,E,F):-hnf(either(A,B,C),D,E,F).
apply(done,A,B,C,D):-hnf(done(A),B,C,D).
apply(putStr,A,putStr(A),B,B).
apply(putStr(A),B,C,D,E):-hnf(putStr(A,B),C,D,E).
apply(putStrLn,A,putStrLn(A),B,B).
apply(putStrLn(A),B,C,D,E):-hnf(putStrLn(A,B),C,D,E).
apply(getLine,A,B,C,D):-hnf(getLine(A),B,C,D).
apply(print,A,print(A),B,B).
apply(print(A),B,C,D,E):-hnf(print(A,B),C,D,E).
apply(doSolve,A,doSolve(A),B,B).
apply(doSolve(A),B,C,D,E):-hnf(doSolve(A,B),C,D,E).
apply(sequenceIO,A,sequenceIO(A),B,B).
apply(sequenceIO(A),B,C,D,E):-hnf(sequenceIO(A,B),C,D,E).
apply(sequenceIO_,A,sequenceIO_(A),B,B).
apply(sequenceIO_(A),B,C,D,E):-hnf(sequenceIO_(A,B),C,D,E).
apply(mapIO,A,mapIO(A),B,B).
apply(mapIO(A),B,mapIO(A,B),C,C).
apply(mapIO(A,B),C,D,E,F):-hnf(mapIO(A,B,C),D,E,F).
apply(mapIO_,A,mapIO_(A),B,B).
apply(mapIO_(A),B,mapIO_(A,B),C,C).
apply(mapIO_(A,B),C,D,E,F):-hnf(mapIO_(A,B,C),D,E,F).
apply(inject,A,inject(A),B,B).
apply(inject(A),B,inject(A,B),C,C).
apply(inject(A,B),C,D,E,F):-hnf(inject(A,B,C),D,E,F).
apply(solveAll,A,B,C,D):-hnf(solveAll(A),B,C,D).
apply(solveAll2,A,B,C,D):-hnf(solveAll2(A),B,C,D).
apply(once,A,once(A),B,B).
apply(once(A),B,C,D,E):-hnf(once(A,B),C,D,E).
apply(one,A,B,C,D):-hnf(one(A),B,C,D).
apply(condSearch,A,condSearch(A),B,B).
apply(condSearch(A),B,C,D,E):-hnf(condSearch(A,B),C,D,E).
apply(best,A,best(A),B,B).
apply(best(A),B,C,D,E):-hnf(best(A,B),C,D,E).
apply(browse,A,browse(A),B,B).
apply(browse(A),B,C,D,E):-hnf(browse(A,B),C,D,E).
apply(browseList,A,browseList(A),B,B).
apply(browseList(A),B,C,D,E):-hnf(browseList(A,B),C,D,E).
apply(unpack,A,B,C,D):-hnf(unpack(A),B,C,D).
apply('PEVAL',A,B,C,D):-hnf('PEVAL'(A),B,C,D).
apply(prelude_lambda0_1961,A,prelude_lambda0_1961(A),B,B).
apply(prelude_lambda0_1961(A),B,prelude_lambda0_1961(A,B),C,C).
apply(prelude_lambda0_1961(A,B),C,D,E,F):-hnf(prelude_lambda0_1961(A,B,C),D,E,F).
apply(prelude_lambda1_1962,A,prelude_lambda1_1962(A),B,B).
apply(prelude_lambda1_1962(A),B,prelude_lambda1_1962(A,B),C,C).
apply(prelude_lambda1_1962(A,B),C,D,E,F):-hnf(prelude_lambda1_1962(A,B,C),D,E,F).
apply(prelude_lambda2_1963,A,prelude_lambda2_1963(A),B,B).
apply(prelude_lambda2_1963(A),B,prelude_lambda2_1963(A,B),C,C).
apply(prelude_lambda2_1963(A,B),C,prelude_lambda2_1963(A,B,C),D,D).
apply(prelude_lambda2_1963(A,B,C),D,E,F,G):-hnf(prelude_lambda2_1963(A,B,C,D),E,F,G).
apply(takep_418,A,takep_418(A),B,B).
apply(takep_418(A),B,C,D,E):-hnf(takep_418(A,B),C,D,E).
apply(dropp_425,A,dropp_425(A),B,B).
apply(dropp_425(A),B,C,D,E):-hnf(dropp_425(A,B),C,D,E).
apply(splitAtp_432,A,splitAtp_432(A),B,B).
apply(splitAtp_432(A),B,C,D,E):-hnf(splitAtp_432(A,B),C,D,E).
apply(prelude_lambda3_1964,A,prelude_lambda3_1964(A),B,B).
apply(prelude_lambda3_1964(A),B,C,D,E):-hnf(prelude_lambda3_1964(A,B),C,D,E).
apply(prelude_lambda4_1965,A,prelude_lambda4_1965(A),B,B).
apply(prelude_lambda4_1965(A),B,C,D,E):-hnf(prelude_lambda4_1965(A,B),C,D,E).
apply(splitline_456,A,B,C,D):-hnf(splitline_456(A),B,C,D).
apply(prelude_lambda5_1966,A,prelude_lambda5_1966(A),B,B).
apply(prelude_lambda5_1966(A),B,C,D,E):-hnf(prelude_lambda5_1966(A,B),C,D,E).
apply(prelude_lambda6_1967,A,B,C,D):-hnf(prelude_lambda6_1967(A),B,C,D).
apply(prelude_lambda7_1968,A,B,C,D):-hnf(prelude_lambda7_1968(A),B,C,D).
apply(isSpace_466,A,B,C,D):-hnf(isSpace_466(A),B,C,D).
apply(prelude_lambda9_1969,A,B,C,D):-hnf(prelude_lambda9_1969(A),B,C,D).
apply(prelude_lambda8_1970,A,B,C,D):-hnf(prelude_lambda8_1970(A),B,C,D).
apply(prelude_lambda10_1971,A,prelude_lambda10_1971(A),B,B).
apply(prelude_lambda10_1971(A),B,C,D,E):-hnf(prelude_lambda10_1971(A,B),C,D,E).
apply(prelude_lambda11_1972,A,prelude_lambda11_1972(A),B,B).
apply(prelude_lambda11_1972(A),B,C,D,E):-hnf(prelude_lambda11_1972(A,B),C,D,E).
apply(prelude_lambda12_1973,A,prelude_lambda12_1973(A),B,B).
apply(prelude_lambda12_1973(A),B,C,D,E):-hnf(prelude_lambda12_1973(A,B),C,D,E).
apply(prelude_lambda13_1974,A,prelude_lambda13_1974(A),B,B).
apply(prelude_lambda13_1974(A),B,prelude_lambda13_1974(A,B),C,C).
apply(prelude_lambda13_1974(A,B),C,D,E,F):-hnf(prelude_lambda13_1974(A,B,C),D,E,F).
apply(p_494,A,p_494(A),B,B).
apply(p_494(A),B,p_494(A,B),C,C).
apply(p_494(A,B),C,p_494(A,B,C),D,D).
apply(p_494(A,B,C),D,E,F,G):-hnf(p_494(A,B,C,D),E,F,G).
apply(prelude_lambda14_1975,A,prelude_lambda14_1975(A),B,B).
apply(prelude_lambda14_1975(A),B,prelude_lambda14_1975(A,B),C,C).
apply(prelude_lambda14_1975(A,B),C,D,E,F):-hnf(prelude_lambda14_1975(A,B,C),D,E,F).
apply(lambdafun_1976,A,lambdafun_1976(A),B,B).
apply(lambdafun_1976(A),B,C,D,E):-hnf(lambdafun_1976(A,B),C,D,E).
apply(lambdafun_1977,A,lambdafun_1977(A),B,B).
apply(lambdafun_1977(A),B,lambdafun_1977(A,B),C,C).
apply(lambdafun_1977(A,B),C,D,E,F):-hnf(lambdafun_1977(A,B,C),D,E,F).
apply(lambdafun_1978,A,lambdafun_1978(A),B,B).
apply(lambdafun_1978(A),B,lambdafun_1978(A,B),C,C).
apply(lambdafun_1978(A,B),C,D,E,F):-hnf(lambdafun_1978(A,B,C),D,E,F).
apply(lambdafun_1979,A,lambdafun_1979(A),B,B).
apply(lambdafun_1979(A),B,lambdafun_1979(A,B),C,C).
apply(lambdafun_1979(A,B),C,D,E,F):-hnf(lambdafun_1979(A,B,C),D,E,F).
apply(prelude_lambda15_1980,A,prelude_lambda15_1980(A),B,B).
apply(prelude_lambda15_1980(A),B,prelude_lambda15_1980(A,B),C,C).
apply(prelude_lambda15_1980(A,B),C,D,E,F):-hnf(prelude_lambda15_1980(A,B,C),D,E,F).
apply(evalall_529,A,B,C,D):-hnf(evalall_529(A),B,C,D).
apply(evalall2_530,A,B,C,D):-hnf(evalall2_530(A),B,C,D).
apply(evalall3_531,A,evalall3_531(A),B,B).
apply(evalall3_531(A),B,C,D,E):-hnf(evalall3_531(A,B),C,D,E).
apply(evalResult_546,A,B,C,D):-hnf(evalResult_546(A),B,C,D).
apply(prelude_lambda16_1981,A,prelude_lambda16_1981(A),B,B).
apply(prelude_lambda16_1981(A),B,C,D,E):-hnf(prelude_lambda16_1981(A,B),C,D,E).
apply(prelude_lambda17_1982,A,prelude_lambda17_1982(A),B,B).
apply(prelude_lambda17_1982(A),B,prelude_lambda17_1982(A,B),C,C).
apply(prelude_lambda17_1982(A,B),C,D,E,F):-hnf(prelude_lambda17_1982(A,B,C),D,E,F).
apply(bestHelp_561,A,bestHelp_561(A),B,B).
apply(bestHelp_561(A),B,bestHelp_561(A,B),C,C).
apply(bestHelp_561(A,B),C,bestHelp_561(A,B,C),D,D).
apply(bestHelp_561(A,B,C),D,E,F,G):-hnf(bestHelp_561(A,B,C,D),E,F,G).
apply(evalB_562,A,evalB_562(A),B,B).
apply(evalB_562(A),B,evalB_562(A,B),C,C).
apply(evalB_562(A,B),C,evalB_562(A,B,C),D,D).
apply(evalB_562(A,B,C),D,E,F,G):-hnf(evalB_562(A,B,C,D),E,F,G).
apply(evalA_563,A,evalA_563(A),B,B).
apply(evalA_563(A),B,evalA_563(A,B),C,C).
apply(evalA_563(A,B),C,evalA_563(A,B,C),D,D).
apply(evalA_563(A,B,C),D,evalA_563(A,B,C,D),E,E).
apply(evalA_563(A,B,C,D),E,F,G,H):-hnf(evalA_563(A,B,C,D,E),F,G,H).
apply(constrain_564,A,constrain_564(A),B,B).
apply(constrain_564(A),B,constrain_564(A,B),C,C).
apply(constrain_564(A,B),C,constrain_564(A,B,C),D,D).
apply(constrain_564(A,B,C),D,E,F,G):-hnf(constrain_564(A,B,C,D),E,F,G).
apply(prelude_lambda18_1983,A,prelude_lambda18_1983(A),B,B).
apply(prelude_lambda18_1983(A),B,prelude_lambda18_1983(A,B),C,C).
apply(prelude_lambda18_1983(A,B),C,D,E,F):-hnf(prelude_lambda18_1983(A,B,C),D,E,F).
apply(&,A,&(A),B,B).
apply(&(A),B,C,D,E):-hnf(&(A,B),C,D,E).
apply(+,A,+(A),B,B).
apply(+(A),B,C,D,E):-hnf(A+B,C,D,E).
apply(-,A,-(A),B,B).
apply(-(A),B,C,D,E):-hnf(A-B,C,D,E).
apply(*,A,*(A),B,B).
apply(*(A),B,C,D,E):-hnf(A*B,C,D,E).
apply(div,A,div(A),B,B).
apply(div(A),B,C,D,E):-hnf(div(A,B),C,D,E).
apply(mod,A,mod(A),B,B).
apply(mod(A),B,C,D,E):-hnf(A mod B,C,D,E).
apply(<,A,<(A),B,B).
apply(<(A),B,C,D,E):-hnf(A<B,C,D,E).
apply(>,A,>(A),B,B).
apply(>(A),B,C,D,E):-hnf(A>B,C,D,E).
apply(<=,A,<=(A),B,B).
apply(<=(A),B,C,D,E):-hnf(<=(A,B),C,D,E).
apply(>=,A,>=(A),B,B).
apply(>=(A),B,C,D,E):-hnf(A>=B,C,D,E).
apply(ord,A,B,C,D):-hnf(ord(A),B,C,D).
apply(chr,A,B,C,D):-hnf(chr(A),B,C,D).
apply(>>=,A,>>=(A),B,B).
apply(>>=(A),B,>>=(A,B),C,C).
apply(>>=(A,B),C,D,E,F):-hnf(>>=(A,B,C),D,E,F).
apply(>>,A,>>(A),B,B).
apply(>>(A),B,A>>B,C,C).
apply(A>>B,C,D,E,F):-hnf(>>(A,B,C),D,E,F).
apply(putChar,A,putChar(A),B,B).
apply(putChar(A),B,C,D,E):-hnf(putChar(A,B),C,D,E).
apply(getChar,A,B,C,D):-hnf(getChar(A),B,C,D).
apply(return,A,return(A),B,B).
apply(return(A),B,C,D,E):-hnf(return(A,B),C,D,E).
apply(readFile,A,readFile(A),B,B).
apply(readFile(A),B,C,D,E):-hnf(readFile(A,B),C,D,E).
apply('#readFileContents',A,'#readFileContents'(A),B,B).
apply('#readFileContents'(A),B,C,D,E):-hnf('#readFileContents'(A,B),C,D,E).
apply(writeFile,A,writeFile(A),B,B).
apply(writeFile(A),B,writeFile(A,B),C,C).
apply(writeFile(A,B),C,D,E,F):-hnf(writeFile(A,B,C),D,E,F).
apply(appendFile,A,appendFile(A),B,B).
apply(appendFile(A),B,appendFile(A,B),C,C).
apply(appendFile(A,B),C,D,E,F):-hnf(appendFile(A,B,C),D,E,F).
apply('#writeFileContents',A,'#writeFileContents'(A),B,B).
apply('#writeFileContents'(A),B,'#writeFileContents'(A,B),C,C).
apply('#writeFileContents'(A,B),C,D,E,F):-hnf('#writeFileContents'(A,B,C),D,E,F).
apply(catchFail,A,catchFail(A),B,B).
apply(catchFail(A),B,catchFail(A,B),C,C).
apply(catchFail(A,B),C,D,E,F):-hnf(catchFail(A,B,C),D,E,F).
apply(findall,A,B,C,D):-hnf(findall(A),B,C,D).
apply(findfirst,A,B,C,D):-hnf(findfirst(A),B,C,D).
apply(show,A,B,C,D):-hnf(show(A),B,C,D).
apply(seq,A,seq(A),B,B).
apply(seq(A),B,C,D,E):-hnf(seq(A,B),C,D,E).
apply(error,A,B,C,D):-hnf(error(A),B,C,D).
apply('Unsafe.unsafePerformIO',A,B,C,D):-hnf('Unsafe.unsafePerformIO'(A),B,C,D).
apply('ACurry.readCurryFile',A,'ACurry.readCurryFile'(A),B,B).
apply('ACurry.readCurryFile'(A),B,C,D,E):-hnf('ACurry.readCurryFile'(A,B),C,D,E).
apply('Flat.readFlatCurryFile',A,'Flat.readFlatCurryFile'(A),B,B).
apply('Flat.readFlatCurryFile'(A),B,C,D,E):-hnf('Flat.readFlatCurryFile'(A,B),C,D,E).
apply('System.getCPUTime',A,B,C,D):-hnf('System.getCPUTime'(A),B,C,D).
apply('System.getElapsedTime',A,B,C,D):-hnf('System.getElapsedTime'(A),B,C,D).
apply('System.getDate',A,B,C,D):-hnf('System.getDate'(A),B,C,D).
apply('System.getArgs',A,B,C,D):-hnf('System.getArgs'(A),B,C,D).
apply('System.getEnviron',A,'System.getEnviron'(A),B,B).
apply('System.getEnviron'(A),B,C,D,E):-hnf('System.getEnviron'(A,B),C,D,E).
apply('System.getHostname',A,B,C,D):-hnf('System.getHostname'(A),B,C,D).
apply('System.getPID',A,B,C,D):-hnf('System.getPID'(A),B,C,D).
apply('System.system',A,'System.system'(A),B,B).
apply('System.system'(A),B,C,D,E):-hnf('System.system'(A,B),C,D,E).
apply('System.sleep',A,'System.sleep'(A),B,B).
apply('System.sleep'(A),B,C,D,E):-hnf('System.sleep'(A,B),C,D,E).
apply('System.evalTime',A,B,C,D):-hnf('System.evalTime'(A),B,C,D).
apply('System.evalSpace',A,B,C,D):-hnf('System.evalSpace'(A),B,C,D).
apply('Time.getClockTime',A,B,C,D):-hnf('Time.getClockTime'(A),B,C,D).
apply('Directory.doesFileExist',A,'Directory.doesFileExist'(A),B,B).
apply('Directory.doesFileExist'(A),B,C,D,E):-hnf('Directory.doesFileExist'(A,B),C,D,E).
apply('Directory.doesDirectoryExist',A,'Directory.doesDirectoryExist'(A),B,B).
apply('Directory.doesDirectoryExist'(A),B,C,D,E):-hnf('Directory.doesDirectoryExist'(A,B),C,D,E).
apply('Directory.getModificationTime',A,'Directory.getModificationTime'(A),B,B).
apply('Directory.getModificationTime'(A),B,C,D,E):-hnf('Directory.getModificationTime'(A,B),C,D,E).
apply('Directory.getDirectoryContents',A,'Directory.getDirectoryContents'(A),B,B).
apply('Directory.getDirectoryContents'(A),B,C,D,E):-hnf('Directory.getDirectoryContents'(A,B),C,D,E).
apply('Term.showTerm',A,B,C,D):-hnf('Term.showTerm'(A),B,C,D).
apply('Term.readTerm',A,B,C,D):-hnf('Term.readTerm'(A),B,C,D).
apply('Term.encodeTerm',A,B,C,D):-hnf('Term.encodeTerm'(A),B,C,D).
apply('Term.decodeTerm',A,B,C,D):-hnf('Term.decodeTerm'(A),B,C,D).
apply('Ports.openPort',A,'Ports.openPort'(A),B,B).
apply('Ports.openPort'(A),B,C,D,E):-hnf('Ports.openPort'(A,B),C,D,E).
apply('#basicserverloop',A,'#basicserverloop'(A),B,B).
apply('#basicserverloop'(A),B,C,D,E):-hnf('#basicserverloop'(A,B),C,D,E).
apply('Ports.send',A,'Ports.send'(A),B,B).
apply('Ports.send'(A),B,C,D,E):-hnf('Ports.send'(A,B),C,D,E).
apply('Ports.openProcessPort',A,'Ports.openProcessPort'(A),B,B).
apply('Ports.openProcessPort'(A),B,C,D,E):-hnf('Ports.openProcessPort'(A,B),C,D,E).
apply('Ports.openSocketConnectPort',A,'Ports.openSocketConnectPort'(A),B,B).
apply('Ports.openSocketConnectPort'(A),B,'Ports.openSocketConnectPort'(A,B),C,C).
apply('Ports.openSocketConnectPort'(A,B),C,D,E,F):-hnf('Ports.openSocketConnectPort'(A,B,C),D,E,F).
apply('Ports.ping',A,'Ports.ping'(A),B,B).
apply('Ports.ping'(A),B,'Ports.ping'(A,B),C,C).
apply('Ports.ping'(A,B),C,D,E,F):-hnf('Ports.ping'(A,B,C),D,E,F).
apply('Ports.timeoutOnStream',A,'Ports.timeoutOnStream'(A),B,B).
apply('Ports.timeoutOnStream'(A),B,C,D,E):-hnf('Ports.timeoutOnStream'(A,B),C,D,E).
apply('Ports.openPortOnSocket',A,'Ports.openPortOnSocket'(A),B,B).
apply('Ports.openPortOnSocket'(A),B,'Ports.openPortOnSocket'(A,B),C,C).
apply('Ports.openPortOnSocket'(A,B),C,D,E,F):-hnf('Ports.openPortOnSocket'(A,B,C),D,E,F).
apply('Ports.connectPortAtSocket',A,'Ports.connectPortAtSocket'(A),B,B).
apply('Ports.connectPortAtSocket'(A),B,'Ports.connectPortAtSocket'(A,B),C,C).
apply('Ports.connectPortAtSocket'(A,B),C,'Ports.connectPortAtSocket'(A,B,C),D,D).
apply('Ports.connectPortAtSocket'(A,B,C),D,E,F,G):-hnf('Ports.connectPortAtSocket'(A,B,C,D),E,F,G).
apply('Ports.choiceSPEP',A,'Ports.choiceSPEP'(A),B,B).
apply('Ports.choiceSPEP'(A),B,C,D,E):-hnf('Ports.choiceSPEP'(A,B),C,D,E).
apply('CLPR.+.',A,'CLPR.+.'(A),B,B).
apply('CLPR.+.'(A),B,C,D,E):-hnf('CLPR.+.'(A,B),C,D,E).
apply('CLPR.-.',A,'CLPR.-.'(A),B,B).
apply('CLPR.-.'(A),B,C,D,E):-hnf('CLPR.-.'(A,B),C,D,E).
apply('CLPR.*.',A,'CLPR.*.'(A),B,B).
apply('CLPR.*.'(A),B,C,D,E):-hnf('CLPR.*.'(A,B),C,D,E).
apply('CLPR./.',A,'CLPR./.'(A),B,B).
apply('CLPR./.'(A),B,C,D,E):-hnf('CLPR./.'(A,B),C,D,E).
apply('CLPR.<.',A,'CLPR.<.'(A),B,B).
apply('CLPR.<.'(A),B,C,D,E):-hnf('CLPR.<.'(A,B),C,D,E).
apply('CLPR.>.',A,'CLPR.>.'(A),B,B).
apply('CLPR.>.'(A),B,C,D,E):-hnf('CLPR.>.'(A,B),C,D,E).
apply('CLPR.<=.',A,'CLPR.<=.'(A),B,B).
apply('CLPR.<=.'(A),B,C,D,E):-hnf('CLPR.<=.'(A,B),C,D,E).
apply('CLPR.>=.',A,'CLPR.>=.'(A),B,B).
apply('CLPR.>=.'(A),B,C,D,E):-hnf('CLPR.>=.'(A,B),C,D,E).
apply('CLPR.i2f',A,B,C,D):-hnf('CLPR.i2f'(A),B,C,D).
apply('CLPFD.+#',A,'CLPFD.+#'(A),B,B).
apply('CLPFD.+#'(A),B,C,D,E):-hnf('CLPFD.+#'(A,B),C,D,E).
apply('CLPFD.-#',A,'CLPFD.-#'(A),B,B).
apply('CLPFD.-#'(A),B,C,D,E):-hnf('CLPFD.-#'(A,B),C,D,E).
apply('CLPFD.*#',A,'CLPFD.*#'(A),B,B).
apply('CLPFD.*#'(A),B,C,D,E):-hnf('CLPFD.*#'(A,B),C,D,E).
apply('CLPFD.=#',A,'CLPFD.=#'(A),B,B).
apply('CLPFD.=#'(A),B,C,D,E):-hnf('CLPFD.=#'(A,B),C,D,E).
apply('CLPFD./=#',A,'CLPFD./=#'(A),B,B).
apply('CLPFD./=#'(A),B,C,D,E):-hnf('CLPFD./=#'(A,B),C,D,E).
apply('CLPFD.<#',A,'CLPFD.<#'(A),B,B).
apply('CLPFD.<#'(A),B,C,D,E):-hnf('CLPFD.<#'(A,B),C,D,E).
apply('CLPFD.>#',A,'CLPFD.>#'(A),B,B).
apply('CLPFD.>#'(A),B,C,D,E):-hnf('CLPFD.>#'(A,B),C,D,E).
apply('CLPFD.<=#',A,'CLPFD.<=#'(A),B,B).
apply('CLPFD.<=#'(A),B,C,D,E):-hnf('CLPFD.<=#'(A,B),C,D,E).
apply('CLPFD.>=#',A,'CLPFD.>=#'(A),B,B).
apply('CLPFD.>=#'(A),B,C,D,E):-hnf('CLPFD.>=#'(A,B),C,D,E).
apply('CLPFD.domain',A,'CLPFD.domain'(A),B,B).
apply('CLPFD.domain'(A),B,'CLPFD.domain'(A,B),C,C).
apply('CLPFD.domain'(A,B),C,D,E,F):-hnf('CLPFD.domain'(A,B,C),D,E,F).
apply('CLPFD.all_different',A,B,C,D):-hnf('CLPFD.all_different'(A),B,C,D).
apply('CLPFD.labeling',A,B,C,D):-hnf('CLPFD.labeling'(A),B,C,D).
apply('TermDB.openDB',A,'TermDB.openDB'(A),B,B).
apply('TermDB.openDB'(A),B,C,D,E):-hnf('TermDB.openDB'(A,B),C,D,E).
apply('TermDB.closeDB',A,'TermDB.closeDB'(A),B,B).
apply('TermDB.closeDB'(A),B,C,D,E):-hnf('TermDB.closeDB'(A,B),C,D,E).
apply('TermDB.storeDB',A,'TermDB.storeDB'(A),B,B).
apply('TermDB.storeDB'(A),B,'TermDB.storeDB'(A,B),C,C).
apply('TermDB.storeDB'(A,B),C,D,E,F):-hnf('TermDB.storeDB'(A,B,C),D,E,F).
apply('TermDB.eraseDB',A,'TermDB.eraseDB'(A),B,B).
apply('TermDB.eraseDB'(A),B,'TermDB.eraseDB'(A,B),C,C).
apply('TermDB.eraseDB'(A,B),C,D,E,F):-hnf('TermDB.eraseDB'(A,B,C),D,E,F).
apply('TermDB.findallDB',A,'TermDB.findallDB'(A),B,B).
apply('TermDB.findallDB'(A),B,'TermDB.findallDB'(A,B),C,C).
apply('TermDB.findallDB'(A,B),C,D,E,F):-hnf('TermDB.findallDB'(A,B,C),D,E,F).
apply('test.succ',A,B,C,D):-hnf('test.succ'(A),B,C,D).
apply('(,)',A,'(,)'(A),B,B).
apply('(,)'(A),B,C,D,E):-hnf('(,)'(A,B),C,D,E).
apply('(,,)',A,'(,,)'(A),B,B).
apply('(,,)'(A),B,'(,,)'(A,B),C,C).
apply('(,,)'(A,B),C,D,E,F):-hnf('(,,)'(A,B,C),D,E,F).
apply('(,,,)',A,'(,,,)'(A),B,B).
apply('(,,,)'(A),B,'(,,,)'(A,B),C,C).
apply('(,,,)'(A,B),C,'(,,,)'(A,B,C),D,D).
apply('(,,,)'(A,B,C),D,E,F,G):-hnf('(,,,)'(A,B,C,D),E,F,G).
apply('(,,,,)',A,'(,,,,)'(A),B,B).
apply('(,,,,)'(A),B,'(,,,,)'(A,B),C,C).
apply('(,,,,)'(A,B),C,'(,,,,)'(A,B,C),D,D).
apply('(,,,,)'(A,B,C),D,'(,,,,)'(A,B,C,D),E,E).
apply('(,,,,)'(A,B,C,D),E,F,G,H):-hnf('(,,,,)'(A,B,C,D,E),F,G,H).
apply('(,,,,,)',A,'(,,,,,)'(A),B,B).
apply('(,,,,,)'(A),B,'(,,,,,)'(A,B),C,C).
apply('(,,,,,)'(A,B),C,'(,,,,,)'(A,B,C),D,D).
apply('(,,,,,)'(A,B,C),D,'(,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,)'(A,B,C,D),E,'(,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,)'(A,B,C,D,E),F,G,H,I):-hnf('(,,,,,)'(A,B,C,D,E,F),G,H,I).
apply('(,,,,,,)',A,'(,,,,,,)'(A),B,B).
apply('(,,,,,,)'(A),B,'(,,,,,,)'(A,B),C,C).
apply('(,,,,,,)'(A,B),C,'(,,,,,,)'(A,B,C),D,D).
apply('(,,,,,,)'(A,B,C),D,'(,,,,,,)'(A,B,C,D),E,E).
apply('(,,,,,,)'(A,B,C,D),E,'(,,,,,,)'(A,B,C,D,E),F,F).
apply('(,,,,,,)'(A,B,C,D,E),F,'(,,,,,,)'(A,B,C,D,E,F),G,G).
apply('(,,,,,,)'(A,B,C,D,E,F),G,H,I,J):-hnf('(,,,,,,)'(A,B,C,D,E,F,G),H,I,J).
apply('.',A,'.'(A),B,B).
apply('.'(A),B,C,D,E):-hnf([A|B],C,D,E).
apply('$io',A,B,C,D):-hnf('$io'(A),B,C,D).
apply('Just',A,B,C,D):-hnf('Just'(A),B,C,D).
apply('Left',A,B,C,D):-hnf('Left'(A),B,C,D).
apply('Right',A,B,C,D):-hnf('Right'(A),B,C,D).
apply('$stream',A,B,C,D):-hnf('$stream'(A),B,C,D).
apply('(,)',A,'(,)'(A),B,B).
apply('(,)'(A),B,C,D,E):-hnf('(,)'(A,B),C,D,E).
apply('(,,)',A,'(,,)'(A),B,B).
apply('(,,)'(A),B,'(,,)'(A,B),C,C).
apply('(,,)'(A,B),C,D,E,F):-hnf('(,,)'(A,B,C),D,E,F).
apply('(,,,)',A,'(,,,)'(A),B,B).
apply('(,,,)'(A),B,'(,,,)'(A,B),C,C).
apply('(,,,)'(A,B),C,'(,,,)'(A,B,C),D,D).
apply('(,,,)'(A,B,C),D,E,F,G):-hnf('(,,,)'(A,B,C,D),E,F,G).
apply('(,,,,)',A,'(,,,,)'(A),B,B).
apply('(,,,,)'(A),B,'(,,,,)'(A,B),C,C).
apply('(,,,,)'(A,B),C,'(,,,,)'(A,B,C),D,D).
apply('(,,,,)'(A,B,C),D,'(,,,,)'(A,B,C,D),E,E).
apply('(,,,,)'(A,B,C,D),E,F,G,H):-hnf('(,,,,)'(A,B,C,D,E),F,G,H).

:- block eq(?,?,-,?).
eq(A,B,C,D):-hnf(A,E,C,F),hnf(B,G,F,H),eq_hnf(E,G,H,D).

:- block eq_hnf(?,?,-,?).
eq_hnf(A,B,C,D):-var(A),!,bind_trynf(A,B,C,D).
eq_hnf(A,B,C,D):-var(B),!,bind_trynf(B,A,C,D).
eq_hnf('test.zero','test.zero',A,A):-!.
eq_hnf('test.succ'(A),'test.succ'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('True','True',A,A):-!.
eq_hnf('False','False',A,A):-!.
eq_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
eq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
eq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,hnf(&(A=:=F,&(B=:=G,&(C=:=H,&(D=:=I,E=:=J)))),M,K,L).
eq_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N):-!,hnf(&(A=:=G,&(B=:=H,&(C=:=I,&(D=:=J,&(E=:=K,F=:=L))))),O,M,N).
eq_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P):-!,hnf(&(A=:=H,&(B=:=I,&(C=:=J,&(D=:=K,&(E=:=L,&(F=:=M,G=:=N)))))),Q,O,P).
eq_hnf([],[],A,A):-!.
eq_hnf([A|B],[C|D],E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf('$io'(A),'$io'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('()','()',A,A):-!.
eq_hnf(success,success,A,A):-!.
eq_hnf('Nothing','Nothing',A,A):-!.
eq_hnf('Just'(A),'Just'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('Left'(A),'Left'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('Right'(A),'Right'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('$stream'(A),'$stream'(B),C,D):-!,hnf(A=:=B,E,C,D).
eq_hnf('()','()',A,A):-!.
eq_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,hnf(&(A=:=C,B=:=D),G,E,F).
eq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,hnf(&(A=:=D,&(B=:=E,C=:=F)),I,G,H).
eq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,hnf(&(A=:=E,&(B=:=F,&(C=:=G,D=:=H))),K,I,J).
eq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,hnf(&(A=:=F,&(B=:=G,&(C=:=H,&(D=:=I,E=:=J)))),M,K,L).
eq_hnf(A,A,B,B):-integer(A),!.
eq_hnf(A,B,C,C):-float(A),!,{A=B}.
eq_hnf(A,B,C,D):-functor(A,E,F),functor(B,G,H),E==G,F==H,gen_eq_hnf_body(1,F,A,B,I),hnf(I,J,C,D).

gen_eq_hnf_body(A,B,C,D,success):-A>B,!.
gen_eq_hnf_body(A,B,C,D,E=:=F):-A=B,!,arg(A,C,E),arg(A,D,F).
gen_eq_hnf_body(A,B,C,D,&(E=:=F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_eq_hnf_body(H,B,C,D,G).

bind_trynf(A,B,C,D):-nf(B,E,C,F),(nonvar(F)->bind_direct(A,E,F,D);bind(A,B,C,D)).
bind_direct(A,B,C,C):-var(B),!,A=B.
bind_direct(A,B,C,C):-occurs_not(A,B),A=B.

bind(A,B,C,C):-var(B),!,A=B.
bind(A,'test.zero',B,B):-!,A='test.zero'.
bind(A,'test.succ'(B),C,D):-!,occurs_not(A,B),A='test.succ'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'True',B,B):-!,A='True'.
bind(A,'False',B,B):-!,A='False'.
bind(A,'(,)'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='(,)'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'(,,)'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='(,,)'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'(,,,)'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='(,,,)'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'(,,,,)'(B,C,D,E,F),G,H):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),A='(,,,,)'(I,J,K,L,M),hnf(B,N,G,O),bind(I,N,O,P),hnf(C,Q,P,R),bind(J,Q,R,S),hnf(D,T,S,U),bind(K,T,U,V),hnf(E,W,V,X),bind(L,W,X,Y),hnf(F,Z,Y,A1),bind(M,Z,A1,H).
bind(A,'(,,,,,)'(B,C,D,E,F,G),H,I):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),A='(,,,,,)'(J,K,L,M,N,O),hnf(B,P,H,Q),bind(J,P,Q,R),hnf(C,S,R,T),bind(K,S,T,U),hnf(D,V,U,W),bind(L,V,W,X),hnf(E,Y,X,Z),bind(M,Y,Z,A1),hnf(F,B1,A1,C1),bind(N,B1,C1,D1),hnf(G,E1,D1,F1),bind(O,E1,F1,I).
bind(A,'(,,,,,,)'(B,C,D,E,F,G,H),I,J):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H),A='(,,,,,,)'(K,L,M,N,O,P,Q),hnf(B,R,I,S),bind(K,R,S,T),hnf(C,U,T,V),bind(L,U,V,W),hnf(D,X,W,Y),bind(M,X,Y,Z),hnf(E,A1,Z,B1),bind(N,A1,B1,C1),hnf(F,D1,C1,E1),bind(O,D1,E1,F1),hnf(G,G1,F1,H1),bind(P,G1,H1,I1),hnf(H,J1,I1,K1),bind(Q,J1,K1,J).
bind(A,[],B,B):-!,A=[].
bind(A,[B|C],D,E):-!,occurs_not(A,B),occurs_not(A,C),A=[F|G],hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'$io'(B),C,D):-!,occurs_not(A,B),A='$io'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'()',B,B):-!,A='()'.
bind(A,success,B,B):-!,A=success.
bind(A,'Nothing',B,B):-!,A='Nothing'.
bind(A,'Just'(B),C,D):-!,occurs_not(A,B),A='Just'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Left'(B),C,D):-!,occurs_not(A,B),A='Left'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'Right'(B),C,D):-!,occurs_not(A,B),A='Right'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'$stream'(B),C,D):-!,occurs_not(A,B),A='$stream'(E),hnf(B,F,C,G),bind(E,F,G,D).
bind(A,'()',B,B):-!,A='()'.
bind(A,'(,)'(B,C),D,E):-!,occurs_not(A,B),occurs_not(A,C),A='(,)'(F,G),hnf(B,H,D,I),bind(F,H,I,J),hnf(C,K,J,L),bind(G,K,L,E).
bind(A,'(,,)'(B,C,D),E,F):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),A='(,,)'(G,H,I),hnf(B,J,E,K),bind(G,J,K,L),hnf(C,M,L,N),bind(H,M,N,O),hnf(D,P,O,Q),bind(I,P,Q,F).
bind(A,'(,,,)'(B,C,D,E),F,G):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),A='(,,,)'(H,I,J,K),hnf(B,L,F,M),bind(H,L,M,N),hnf(C,O,N,P),bind(I,O,P,Q),hnf(D,R,Q,S),bind(J,R,S,T),hnf(E,U,T,V),bind(K,U,V,G).
bind(A,'(,,,,)'(B,C,D,E,F),G,H):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),A='(,,,,)'(I,J,K,L,M),hnf(B,N,G,O),bind(I,N,O,P),hnf(C,Q,P,R),bind(J,Q,R,S),hnf(D,T,S,U),bind(K,T,U,V),hnf(E,W,V,X),bind(L,W,X,Y),hnf(F,Z,Y,A1),bind(M,Z,A1,H).
bind(A,B,C,C):-integer(B),!,A=B.
bind(A,B,C,C):-float(B),!,{A=B}.
bind(A,B,C,D):-functor(B,E,F),occurs_not_args(1,F,A,B),functor(A,E,F),bind_args(1,F,A,B,C,D).

occurs_not_args(A,B,C,D):-A>B,!.
occurs_not_args(A,B,C,D):-arg(A,D,E),occurs_not(C,E),F is A+1,occurs_not_args(F,B,C,D).

bind_args(A,B,C,D,E,E):-A>B,!.
bind_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),hnf(H,I,E,J),bind(G,I,J,K),L is A+1,bind_args(L,B,C,D,K,F).

occurs_not(A,B):-var(B),!,A\==B.
occurs_not(A,'test.zero'):-!.
occurs_not(A,'test.succ'(B)):-!,occurs_not(A,B).
occurs_not(A,'True'):-!.
occurs_not(A,'False'):-!.
occurs_not(A,'(,)'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'(,,)'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'(,,,)'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'(,,,,)'(B,C,D,E,F)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F).
occurs_not(A,'(,,,,,)'(B,C,D,E,F,G)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G).
occurs_not(A,'(,,,,,,)'(B,C,D,E,F,G,H)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F),occurs_not(A,G),occurs_not(A,H).
occurs_not(A,[]):-!.
occurs_not(A,[B|C]):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'$io'(B)):-!,occurs_not(A,B).
occurs_not(A,'()'):-!.
occurs_not(A,success):-!.
occurs_not(A,'Nothing'):-!.
occurs_not(A,'Just'(B)):-!,occurs_not(A,B).
occurs_not(A,'Left'(B)):-!,occurs_not(A,B).
occurs_not(A,'Right'(B)):-!,occurs_not(A,B).
occurs_not(A,'$stream'(B)):-!,occurs_not(A,B).
occurs_not(A,'()'):-!.
occurs_not(A,'(,)'(B,C)):-!,occurs_not(A,B),occurs_not(A,C).
occurs_not(A,'(,,)'(B,C,D)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D).
occurs_not(A,'(,,,)'(B,C,D,E)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E).
occurs_not(A,'(,,,,)'(B,C,D,E,F)):-!,occurs_not(A,B),occurs_not(A,C),occurs_not(A,D),occurs_not(A,E),occurs_not(A,F).
occurs_not(_,_).

:- block seq(?,?,?,-,?).
seq(A,B,C,D,E):-hnf(A,F,D,G),hnf(B,H,G,I),seq_hnf(F,H,C,I,E).

:- block seq_hnf(-,?,?,?,?), seq_hnf(?,-,?,?,?), seq_hnf(?,?,?,-,?).
seq_hnf('test.zero','test.zero',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('test.succ'(A),'test.succ'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('True','True',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('False','False',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('(,)'(A,B),'(,)'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
seq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
seq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L,M):-!,hnf(&&(A==F,&&(B==G,&&(C==H,&&(D==I,&&(E==J,'True'))))),K,L,M).
seq_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N,O):-!,hnf(&&(A==G,&&(B==H,&&(C==I,&&(D==J,&&(E==K,&&(F==L,'True')))))),M,N,O).
seq_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P,Q):-!,hnf(&&(A==H,&&(B==I,&&(C==J,&&(D==K,&&(E==L,&&(F==M,&&(G==N,'True'))))))),O,P,Q).
seq_hnf([],[],A,B,C):-!,hnf('True',A,B,C).
seq_hnf([A|B],[C|D],E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf('$io'(A),'$io'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('()','()',A,B,C):-!,hnf('True',A,B,C).
seq_hnf(success,success,A,B,C):-!,hnf('True',A,B,C).
seq_hnf('Nothing','Nothing',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('Just'(A),'Just'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('Left'(A),'Left'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('Right'(A),'Right'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('$stream'(A),'$stream'(B),C,D,E):-!,hnf(&&(A==B,'True'),C,D,E).
seq_hnf('()','()',A,B,C):-!,hnf('True',A,B,C).
seq_hnf('(,)'(A,B),'(,)'(C,D),E,F,G):-!,hnf(&&(A==C,&&(B==D,'True')),E,F,G).
seq_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H,I):-!,hnf(&&(A==D,&&(B==E,&&(C==F,'True'))),G,H,I).
seq_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J,K):-!,hnf(&&(A==E,&&(B==F,&&(C==G,&&(D==H,'True')))),I,J,K).
seq_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L,M):-!,hnf(&&(A==F,&&(B==G,&&(C==H,&&(D==I,&&(E==J,'True'))))),K,L,M).
seq_hnf(A,B,C,D,D):-number(A),!,(A==B->C='True';C='False').
seq_hnf(A,B,C,D,E):-functor(A,F,G),functor(B,H,I),(F==H,G==I,gen_seq_hnf_body(1,G,A,B,J)->hnf(J,C,D,E);D=E,C='False').

gen_seq_hnf_body(A,B,C,D,'True'):-A>B,!.
gen_seq_hnf_body(A,B,C,D,&&(E==F,G)):-arg(A,C,E),arg(A,D,F),H is A+1,gen_seq_hnf_body(H,B,C,D,G).

:- block nf(?,?,-,?).
nf(A,B,C,D):-hnf(A,E,C,F),nf_hnf(E,B,F,D).

:- block nf_hnf(?,?,-,?).
nf_hnf(A,B,C,C):-var(A),!,B=A.
nf_hnf('test.zero','test.zero',A,A):-!.
nf_hnf('test.succ'(A),'test.succ'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('True','True',A,A):-!.
nf_hnf('False','False',A,A):-!.
nf_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,nf(A,F,K,M),nf(B,G,M,N),nf(C,H,N,O),nf(D,I,O,P),nf(E,J,P,L).
nf_hnf('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L),M,N):-!,nf(A,G,M,O),nf(B,H,O,P),nf(C,I,P,Q),nf(D,J,Q,R),nf(E,K,R,S),nf(F,L,S,N).
nf_hnf('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N),O,P):-!,nf(A,H,O,Q),nf(B,I,Q,R),nf(C,J,R,S),nf(D,K,S,T),nf(E,L,T,U),nf(F,M,U,V),nf(G,N,V,P).
nf_hnf([],[],A,A):-!.
nf_hnf([A|B],[C|D],E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('$io'(A),'$io'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('()','()',A,A):-!.
nf_hnf(success,success,A,A):-!.
nf_hnf('Nothing','Nothing',A,A):-!.
nf_hnf('Just'(A),'Just'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Left'(A),'Left'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('Right'(A),'Right'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('$stream'(A),'$stream'(B),C,D):-!,nf(A,B,C,D).
nf_hnf('()','()',A,A):-!.
nf_hnf('(,)'(A,B),'(,)'(C,D),E,F):-!,nf(A,C,E,G),nf(B,D,G,F).
nf_hnf('(,,)'(A,B,C),'(,,)'(D,E,F),G,H):-!,nf(A,D,G,I),nf(B,E,I,J),nf(C,F,J,H).
nf_hnf('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H),I,J):-!,nf(A,E,I,K),nf(B,F,K,L),nf(C,G,L,M),nf(D,H,M,J).
nf_hnf('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J),K,L):-!,nf(A,F,K,M),nf(B,G,M,N),nf(C,H,N,O),nf(D,I,O,P),nf(E,J,P,L).
nf_hnf(A,A,B,B):-number(A),!.
nf_hnf(A,B,C,D):-functor(A,E,F),functor(B,E,F),nf_hnf_args(1,F,A,B,C,D).

nf_hnf_args(A,B,C,D,E,E):-A>B,!.
nf_hnf_args(A,B,C,D,E,F):-arg(A,C,G),arg(A,D,H),nf(G,H,E,I),J is A+1,nf_hnf_args(J,B,C,D,I,F).

propagateShare(A,A):-var(A),!.
propagateShare('test.zero','test.zero'):-!.
propagateShare('test.succ'(A),'test.succ'(B)):-!,propSharArg(A,B).
propagateShare('True','True'):-!.
propagateShare('False','False'):-!.
propagateShare('(,)'(A,B),'(,)'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('(,,)'(A,B,C),'(,,)'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J)):-!,propSharArg(A,F),propSharArg(B,G),propSharArg(C,H),propSharArg(D,I),propSharArg(E,J).
propagateShare('(,,,,,)'(A,B,C,D,E,F),'(,,,,,)'(G,H,I,J,K,L)):-!,propSharArg(A,G),propSharArg(B,H),propSharArg(C,I),propSharArg(D,J),propSharArg(E,K),propSharArg(F,L).
propagateShare('(,,,,,,)'(A,B,C,D,E,F,G),'(,,,,,,)'(H,I,J,K,L,M,N)):-!,propSharArg(A,H),propSharArg(B,I),propSharArg(C,J),propSharArg(D,K),propSharArg(E,L),propSharArg(F,M),propSharArg(G,N).
propagateShare([],[]):-!.
propagateShare([A|B],[C|D]):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('$io'(A),'$io'(B)):-!,propSharArg(A,B).
propagateShare('()','()'):-!.
propagateShare(success,success):-!.
propagateShare('Nothing','Nothing'):-!.
propagateShare('Just'(A),'Just'(B)):-!,propSharArg(A,B).
propagateShare('Left'(A),'Left'(B)):-!,propSharArg(A,B).
propagateShare('Right'(A),'Right'(B)):-!,propSharArg(A,B).
propagateShare('()','()'):-!.
propagateShare('(,)'(A,B),'(,)'(C,D)):-!,propSharArg(A,C),propSharArg(B,D).
propagateShare('(,,)'(A,B,C),'(,,)'(D,E,F)):-!,propSharArg(A,D),propSharArg(B,E),propSharArg(C,F).
propagateShare('(,,,)'(A,B,C,D),'(,,,)'(E,F,G,H)):-!,propSharArg(A,E),propSharArg(B,F),propSharArg(C,G),propSharArg(D,H).
propagateShare('(,,,,)'(A,B,C,D,E),'(,,,,)'(F,G,H,I,J)):-!,propSharArg(A,F),propSharArg(B,G),propSharArg(C,H),propSharArg(D,I),propSharArg(E,J).
propagateShare('Ports.internalPort'(A,B,C,D),'Ports.internalPort'(A,B,C,D)):-!.
propagateShare('$stream'(A),'$stream'(A)):-!.
propagateShare(A,A):-number(A),!.
propagateShare(A,B):-functor(A,C,D),functor(B,C,D),propagateShare_args(1,D,A,B).

propagateShare_args(A,B,C,D):-A>B,!.
propagateShare_args(A,B,C,D):-arg(A,C,E),arg(A,D,F),propSharArg(E,F),G is A+1,propagateShare_args(G,B,C,D).

translate(:,'.').
translate('.','$comp').
translate(natural,'test.natural').
translate(even,'test.even').
translate(zero,'test.zero').
translate(succ,'test.succ').
translate('Int','Int').
translate('True','True').
translate('False','False').
translate('Bool','Bool').
translate([],[]).
translate('(,)','(,)').
translate('(,,)','(,,)').
translate('(,,,)','(,,,)').
translate('(,,,,)','(,,,,)').
translate('(,,,,,)','(,,,,,)').
translate('(,,,,,,)','(,,,,,,)').
translate('Success','Success').
translate(success,success).
translate('$io','$io').
translate('IO','IO').
translate('()','()').
translate('Ports.internalPort','Ports.internalPort').
translate('Port','Port').
translate('Float','Float').
translate('Char','Char').
translate('()','()').
translate('Bool','Bool').
translate('String','String').
translate('Int','Int').
translate('Success','Success').
translate('IO','IO').
translate([],[]).
translate('Either','Either').
translate('<tuple>','<tuple>').
translate('Maybe','Maybe').
translate(&&,&&).
translate(concat,concat).
translate('Nothing','Nothing').
translate(uncurry,uncurry).
translate(dropWhile,dropWhile).
translate('False','False').
translate(curry,curry).
translate(foldr,foldr).
translate(doSolve,doSolve).
translate(=:=,=:=).
translate(appendFile,appendFile).
translate(error,error).
translate(getLine,getLine).
translate(foldl,foldl).
translate(enumFromThenTo,enumFromThenTo).
translate(browse,browse).
translate(browseList,browseList).
translate(sequenceIO,sequenceIO).
translate(repeat,repeat).
translate(length,length).
translate(head,head).
translate(null,null).
translate('Just','Just').
translate(++,++).
translate(>>,>>).
translate(>=,>=).
translate(one,one).
translate(putStr,putStr).
translate(flip,flip).
translate(snd,snd).
translate(unzip,unzip).
translate(replicate,replicate).
translate('()','()').
translate('$!','$!').
translate(takeWhile,takeWhile).
translate([],[]).
translate(const,const).
translate(==,==).
translate('PEVAL','PEVAL').
translate(any,any).
translate(mapIO,mapIO).
translate(condSearch,condSearch).
translate('Left','Left').
translate(unwords,unwords).
translate(findall,findall).
translate(if_then_else,if_then_else).
translate(words,words).
translate(show,show).
translate('||','||').
translate(drop,drop).
translate(id,id).
translate(or,or).
translate(catchFail,catchFail).
translate(and,and).
translate(readFile,readFile).
translate(/=,/=).
translate(getChar,getChar).
translate(<=,<=).
translate(foldl1,foldl1).
translate(take,take).
translate(mapIO_,mapIO_).
translate(mod,mod).
translate(success,success).
translate(unzip3,unzip3).
translate(otherwise,otherwise).
translate(concatMap,concatMap).
translate(reverse,reverse).
translate('<unary-minus>','<unary-minus>').
translate(zipWith,zipWith).
translate(enumFromThen,enumFromThen).
translate(putChar,putChar).
translate(seq,seq).
translate(putStrLn,putStrLn).
translate(foldr1,foldr1).
translate(ord,ord).
translate(zip3,zip3).
translate(map,map).
translate(elem,elem).
translate('True','True').
translate(lookup,lookup).
translate(zipWith3,zipWith3).
translate(unpack,unpack).
translate(sequenceIO_,sequenceIO_).
translate(>,>).
translate(<,<).
translate('.','.').
translate(>>=,>>=).
translate(filter,filter).
translate(writeFile,writeFile).
translate(until,until).
translate(not,not).
translate(unlines,unlines).
translate(findfirst,findfirst).
translate(span,span).
translate(lines,lines).
translate('$comp','$comp').
translate(-,-).
translate(all,all).
translate(solveAll,solveAll).
translate(+,+).
translate(*,*).
translate(if_then_else,if_then_else).
translate('!!','!!').
translate(tryone,tryone).
translate(tail,tail).
translate(either,either).
translate(&,&).
translate(enumFrom,enumFrom).
translate(print,print).
translate(inject,inject).
translate($,$).
translate(notElem,notElem).
translate(failed,failed).
translate(try,try).
translate(return,return).
translate(done,done).
translate(solveAll2,solveAll2).
translate(zip,zip).
translate(splitAt,splitAt).
translate(best,best).
translate(break,break).
translate(maybe,maybe).
translate(chr,chr).
translate(&>,&>).
translate('<tuple>','<tuple>').
translate(iterate,iterate).
translate('Right','Right').
translate(enumFromTo,enumFromTo).
translate(div,div).
translate(once,once).
translate(fst,fst).
functiontype('test.even',[tcons('test.natural',[]),tcons('Bool',[])]).
functiontype(seq,[tvar(A),tvar(B),tvar(B)]).
functiontype(error,[tcons([],[tcons('Char',[])]),tvar(A)]).
functiontype(==,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(ord,[tcons('Char',[]),tcons('Int',[])]).
functiontype(chr,[tcons('Int',[]),tcons('Char',[])]).
functiontype(+,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(-,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(*,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(div,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(mod,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(<,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(>,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(<=,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(>=,[tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(=:=,[tvar(A),tvar(A),tcons('Success',[])]).
functiontype(success,[tcons('Success',[])]).
functiontype(&,[tcons('Success',[]),tcons('Success',[]),tcons('Success',[])]).
functiontype(>>=,[tcons('IO',[tvar(A)]),functype(tvar(A),tcons('IO',[tvar(B)])),tcons('IO',[tvar(B)])]).
functiontype(return,[tvar(A),tcons('IO',[tvar(A)])]).
functiontype(putChar,[tcons('Char',[]),tcons('IO',[tcons('()',[])])]).
functiontype(getChar,[tcons('IO',[tcons('Char',[])])]).
functiontype(readFile,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(writeFile,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(appendFile,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(catchFail,[tcons('IO',[tvar(A)]),tcons('IO',[tvar(A)]),tcons('IO',[tvar(A)])]).
functiontype(show,[tvar(A),tcons([],[tcons('Char',[])])]).
functiontype(try,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype('$comp',[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(A)),tvar(C),tvar(B)]).
functiontype(id,[tvar(A),tvar(A)]).
functiontype(const,[tvar(A),tvar(B),tvar(A)]).
functiontype(curry,[functype(tcons('(,)',[tvar(A),tvar(B)]),tvar(C)),tvar(A),tvar(B),tvar(C)]).
functiontype(uncurry,[functype(tvar(A),functype(tvar(B),tvar(C))),tcons('(,)',[tvar(A),tvar(B)]),tvar(C)]).
functiontype(flip,[functype(tvar(A),functype(tvar(B),tvar(C))),tvar(B),tvar(A),tvar(C)]).
functiontype(until,[functype(tvar(A),tcons('Bool',[])),functype(tvar(A),tvar(A)),tvar(A),tvar(A)]).
functiontype($,[functype(tvar(A),tvar(B)),tvar(A),tvar(B)]).
functiontype('$!',[functype(tvar(A),tvar(B)),tvar(A),tvar(B)]).
functiontype(failed,[tvar(A)]).
functiontype(&&,[tcons('Bool',[]),tcons('Bool',[]),tcons('Bool',[])]).
functiontype('||',[tcons('Bool',[]),tcons('Bool',[]),tcons('Bool',[])]).
functiontype(not,[tcons('Bool',[]),tcons('Bool',[])]).
functiontype(otherwise,[tcons('Bool',[])]).
functiontype(if_then_else,[tcons('Bool',[]),tvar(A),tvar(A),tvar(A)]).
functiontype(/=,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(fst,[tcons('(,)',[tvar(A),tvar(B)]),tvar(A)]).
functiontype(snd,[tcons('(,)',[tvar(A),tvar(B)]),tvar(B)]).
functiontype(head,[tcons([],[tvar(A)]),tvar(A)]).
functiontype(tail,[tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(null,[tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(++,[tcons([],[tvar(A)]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(length,[tcons([],[tvar(A)]),tcons('Int',[])]).
functiontype('!!',[tcons([],[tvar(A)]),tcons('Int',[]),tvar(A)]).
functiontype(map,[functype(tvar(A),tvar(B)),tcons([],[tvar(A)]),tcons([],[tvar(B)])]).
functiontype(foldl,[functype(tvar(A),functype(tvar(B),tvar(A))),tvar(A),tcons([],[tvar(B)]),tvar(A)]).
functiontype(foldl1,[functype(tvar(A),functype(tvar(A),tvar(A))),tcons([],[tvar(A)]),tvar(A)]).
functiontype(foldr,[functype(tvar(A),functype(tvar(B),tvar(B))),tvar(B),tcons([],[tvar(A)]),tvar(B)]).
functiontype(foldr1,[functype(tvar(A),functype(tvar(A),tvar(A))),tcons([],[tvar(A)]),tvar(A)]).
functiontype(filter,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(zip,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tcons('(,)',[tvar(A),tvar(B)])])]).
functiontype(zip3,[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)]),tcons([],[tcons('(,,)',[tvar(A),tvar(B),tvar(C)])])]).
functiontype(zipWith,[functype(tvar(A),functype(tvar(B),tvar(C))),tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])]).
functiontype(zipWith3,[functype(tvar(A),functype(tvar(B),functype(tvar(C),tvar(D)))),tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)]),tcons([],[tvar(D)])]).
functiontype(unzip,[tcons([],[tcons('(,)',[tvar(A),tvar(B)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])])]).
functiontype(unzip3,[tcons([],[tcons('(,,)',[tvar(A),tvar(B),tvar(C)])]),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])])]).
functiontype(concat,[tcons([],[tcons([],[tvar(A)])]),tcons([],[tvar(A)])]).
functiontype(concatMap,[functype(tvar(A),tcons([],[tvar(B)])),tcons([],[tvar(A)]),tcons([],[tvar(B)])]).
functiontype(iterate,[functype(tvar(A),tvar(A)),tvar(A),tcons([],[tvar(A)])]).
functiontype(repeat,[tvar(A),tcons([],[tvar(A)])]).
functiontype(replicate,[tcons('Int',[]),tvar(A),tcons([],[tvar(A)])]).
functiontype(take,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(drop,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(splitAt,[tcons('Int',[]),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(takeWhile,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(dropWhile,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(span,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(break,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(lines,[tcons([],[tcons('Char',[])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(unlines,[tcons([],[tcons([],[tcons('Char',[])])]),tcons([],[tcons('Char',[])])]).
functiontype(words,[tcons([],[tcons('Char',[])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(unwords,[tcons([],[tcons([],[tcons('Char',[])])]),tcons([],[tcons('Char',[])])]).
functiontype(reverse,[tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(and,[tcons([],[tcons('Bool',[])]),tcons('Bool',[])]).
functiontype(or,[tcons([],[tcons('Bool',[])]),tcons('Bool',[])]).
functiontype(any,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(all,[functype(tvar(A),tcons('Bool',[])),tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(elem,[tvar(A),tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(notElem,[tvar(A),tcons([],[tvar(A)]),tcons('Bool',[])]).
functiontype(lookup,[tvar(A),tcons([],[tcons('(,)',[tvar(A),tvar(B)])]),tcons('Maybe',[tvar(B)])]).
functiontype(enumFrom,[tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromThen,[tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromTo,[tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(enumFromThenTo,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons([],[tcons('Int',[])])]).
functiontype(&>,[tcons('Success',[]),tcons('Success',[]),tcons('Success',[])]).
functiontype(maybe,[tvar(A),functype(tvar(B),tvar(A)),tcons('Maybe',[tvar(B)]),tvar(A)]).
functiontype(either,[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(B)),tcons('Either',[tvar(A),tvar(C)]),tvar(B)]).
functiontype(>>,[tcons('IO',[tvar(A)]),tcons('IO',[tvar(B)]),tcons('IO',[tvar(B)])]).
functiontype(done,[tcons('IO',[tcons('()',[])])]).
functiontype(putStr,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(putStrLn,[tcons([],[tcons('Char',[])]),tcons('IO',[tcons('()',[])])]).
functiontype(getLine,[tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(print,[tvar(A),tcons('IO',[tcons('()',[])])]).
functiontype(doSolve,[tcons('Success',[]),tcons('IO',[tcons('()',[])])]).
functiontype(sequenceIO,[tcons([],[tcons('IO',[tvar(A)])]),tcons('IO',[tcons([],[tvar(A)])])]).
functiontype(sequenceIO_,[tcons([],[tcons('IO',[tvar(A)])]),tcons('IO',[tcons('()',[])])]).
functiontype(mapIO,[functype(tvar(A),tcons('IO',[tvar(B)])),tcons([],[tvar(A)]),tcons('IO',[tcons([],[tvar(B)])])]).
functiontype(mapIO_,[functype(tvar(A),tcons('IO',[tvar(B)])),tcons([],[tvar(A)]),tcons('IO',[tcons('()',[])])]).
functiontype(inject,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(solveAll,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(solveAll2,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(once,[functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(tryone,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype(one,[functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(condSearch,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Bool',[])),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(best,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(findall,[functype(tvar(A),tcons('Success',[])),tcons([],[tvar(A)])]).
functiontype(findfirst,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype(browse,[functype(tvar(A),tcons('Success',[])),tcons('IO',[tcons('()',[])])]).
functiontype(browseList,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons('IO',[tcons('()',[])])]).
functiontype(unpack,[functype(tvar(A),tcons('Success',[])),tvar(A)]).
functiontype('PEVAL',[tvar(A),tvar(A)]).
functiontype(prelude_lambda0_1961,[functype(tvar(A),tvar(B)),functype(tvar(C),tvar(A)),tvar(C),tvar(B)]).
functiontype(prelude_lambda1_1962,[tvar(A),tvar(B),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)])])]).
functiontype(prelude_lambda2_1963,[tvar(A),tvar(B),tvar(C),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])]),tcons('(,,)',[tcons([],[tvar(A)]),tcons([],[tvar(B)]),tcons([],[tvar(C)])])]).
functiontype(takep_418,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(dropp_425,[tcons('Int',[]),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype(splitAtp_432,[tcons('Int',[]),tcons([],[tvar(A)]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(prelude_lambda3_1964,[tvar(A),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(prelude_lambda4_1965,[tvar(A),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])]),tcons('(,)',[tcons([],[tvar(A)]),tcons([],[tvar(A)])])]).
functiontype(splitline_456,[tcons([],[tcons('Char',[])]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda5_1966,[tcons('Char',[]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]),tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda6_1967,[tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda7_1968,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]).
functiontype(isSpace_466,[tcons('Char',[]),tcons('Bool',[])]).
functiontype(prelude_lambda9_1969,[tcons('(,)',[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda8_1970,[tcons([],[tcons('Char',[])]),tcons([],[tcons([],[tcons('Char',[])])])]).
functiontype(prelude_lambda10_1971,[tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])]),tcons([],[tcons('Char',[])])]).
functiontype(prelude_lambda11_1972,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(prelude_lambda12_1973,[tvar(A),tvar(A),tcons('Bool',[])]).
functiontype(prelude_lambda13_1974,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Int',[])]).
functiontype(p_494,[tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Int',[]),tcons('Bool',[])]).
functiontype(prelude_lambda14_1975,[tcons('IO',[tvar(A)]),tvar(B),tcons('IO',[tvar(A)])]).
functiontype(lambdafun_1976,[tcons('Char',[]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(lambdafun_1977,[tcons('Char',[]),tcons([],[tcons('Char',[])]),tcons('IO',[tcons([],[tcons('Char',[])])])]).
functiontype(lambdafun_1978,[tvar(A),tcons([],[tvar(A)]),tcons('IO',[tcons([],[tvar(A)])])]).
functiontype(lambdafun_1979,[tcons([],[tcons('IO',[tvar(A)])]),tvar(A),tcons('IO',[tcons([],[tvar(A)])])]).
functiontype(prelude_lambda15_1980,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(evalall_529,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalall2_530,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalall3_531,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalResult_546,[tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(prelude_lambda16_1981,[functype(tvar(A),tcons('Success',[])),tvar(A),tcons('Success',[])]).
functiontype(prelude_lambda17_1982,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),tcons('Bool',[])),tvar(A),tcons('Success',[])]).
functiontype(bestHelp_561,[functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalB_562,[functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(evalA_563,[functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))]),tcons([],[functype(tvar(A),tcons('Success',[]))])]).
functiontype(constrain_564,[functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),functype(tvar(A),tcons('Success',[])),tcons([],[functype(tvar(A),tcons('Success',[]))]),tvar(A),tcons('Success',[])]).
functiontype(prelude_lambda18_1983,[functype(tvar(A),tcons('Success',[])),functype(tvar(A),functype(tvar(A),tcons('Bool',[]))),tvar(A),tcons('Success',[])]).

functiontype('test.zero',[tcons('test.natural',[])]).
functiontype('test.succ',[tcons('test.natural',[]),tcons('test.natural',[])]).
functiontype('True',[tcons('Bool',[])]).
functiontype('False',[tcons('Bool',[])]).
functiontype('(,)',[tvar(A),tvar(B),tcons('(,)',[tvar(A),tvar(B)])]).
functiontype('(,,)',[tvar(A),tvar(B),tvar(C),tcons('(,,)',[tvar(A),tvar(B),tvar(C)])]).
functiontype('(,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tcons('(,,,)',[tvar(A),tvar(B),tvar(C),tvar(D)])]).
functiontype('(,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E),tcons('(,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E)])]).
functiontype('(,,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E),tvar(F),tcons('(,,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E),tvar(F)])]).
functiontype('(,,,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E),tvar(F),tvar(G),tcons('(,,,,,,)',[tvar(A),tvar(B),tvar(C),tvar(D),tvar(E),tvar(F)])]).
functiontype([],[tcons([],[tvar(A)])]).
functiontype('.',[tvar(A),tcons([],[tvar(A)]),tcons([],[tvar(A)])]).
functiontype('$io',[tvar(A),tcons('IO',[tvar(A)])]).
functiontype('()',[tcons('()',[])]).
functiontype(success,[tcons('Success',[])]).
functiontype('Nothing',[tcons('Maybe',[tvar(A)])]).
functiontype('Just',[tvar(A),tcons('Maybe',[tvar(A)])]).
functiontype('Left',[tvar(A),tcons('Either',[tvar(A),tvar(B)])]).
functiontype('Right',[tvar(A),tcons('Either',[tvar(B),tvar(A)])]).

evaluation('test.even','Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('test.zero',[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('test.succ',[1]),'Case'('Flex','Var'(1),['Branch'('Pattern'('test.succ',[2]),'Comb'('FuncCall','test.even',['Var'(2)]))]))]))).
evaluation(==,'External'(==)).
evaluation(=:=,'External'(=:=)).
evaluation(success,'External'(success)).
evaluation('$comp','Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda0_1961,['Var'(0),'Var'(1)]),'Var'(2)))).
evaluation(id,'Rule'([0],'Var'(0))).
evaluation(const,'Rule'([0,1],'Var'(0))).
evaluation(curry,'Rule'([0,1,2],'Apply'('Var'(0),'Comb'('ConsCall','(,)',['Var'(1),'Var'(2)])))).
evaluation(uncurry,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(3)))]))).
evaluation(flip,'Rule'([0,1,2],'Apply'('Apply'('Var'(0),'Var'(2)),'Var'(1)))).
evaluation(until,'Rule'([0,1,2],'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Var'(2),'Comb'('FuncCall',until,['Var'(0),'Var'(1),'Apply'('Var'(1),'Var'(2))])]))).
evaluation($,'Rule'([0,1],'Apply'('Var'(0),'Var'(1)))).
evaluation('$!','Rule'([0,1],'Comb'('FuncCall',seq,['Var'(1),'Apply'('Var'(0),'Var'(1))]))).
evaluation(failed,'Rule'([],'GuardedExpr'([0],'Constr'([],'Comb'('FuncCall',=:=,['Lit'('Intc'(1)),'Lit'('Intc'(2))])),'Var'(0)))).
evaluation(&&,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Var'(1)),'Branch'('Pattern'('False',[]),'Comb'('ConsCall','False',[]))]))).
evaluation('||','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('False',[]),'Var'(1))]))).
evaluation(not,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('True',[]),'Comb'('ConsCall','False',[])),'Branch'('Pattern'('False',[]),'Comb'('ConsCall','True',[]))]))).
evaluation(otherwise,'Rule'([],'Comb'('ConsCall','True',[]))).
evaluation(if_then_else,'Rule'([0,1,2],'Case'('Rigid','Var'(0),['Branch'('Pattern'('True',[]),'Var'(1)),'Branch'('Pattern'('False',[]),'Var'(2))]))).
evaluation(/=,'Rule'([0,1],'Comb'('FuncCall',not,['Comb'('FuncCall',==,['Var'(0),'Var'(1)])]))).
evaluation(fst,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Var'(1))]))).
evaluation(snd,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Var'(2))]))).
evaluation(head,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[1,2]),'Var'(1))]))).
evaluation(tail,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[1,2]),'Var'(2))]))).
evaluation(null,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','True',[])),'Branch'('Pattern'('.',[1,2]),'Comb'('ConsCall','False',[]))]))).
evaluation(++,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',++,['Var'(3),'Var'(1)])]))]))).
evaluation(length,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Lit'('Intc'(0))),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',+,['Lit'('Intc'(1)),'Comb'('FuncCall',length,['Var'(2)])]))]))).
evaluation('!!','Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Intc'(0))]),'Var'(2),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(1),'Lit'('Intc'(0))]),'Comb'('FuncCall','!!',['Var'(3),'Comb'('FuncCall',-,['Var'(1),'Lit'('Intc'(1))])]),'Comb'('FuncCall',failed,[])])]))]))).
evaluation(map,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',map,['Var'(0),'Var'(3)])]))]))).
evaluation(foldl,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',foldl,['Var'(0),'Apply'('Apply'('Var'(0),'Var'(1)),'Var'(3)),'Var'(4)]))]))).
evaluation(foldl1,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',foldl,['Var'(0),'Var'(2),'Var'(3)]))]))).
evaluation(foldr,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(1)),'Branch'('Pattern'('.',[3,4]),'Apply'('Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',foldr,['Var'(0),'Var'(1),'Var'(4)])))]))).
evaluation(foldr1,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Var'(2)),'Branch'('Pattern'('.',[4,5]),'Apply'('Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',foldr1,['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Var'(5)])])))]))]))).
evaluation(filter,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]),'Comb'('FuncCall',filter,['Var'(0),'Var'(3)])]))]))).
evaluation(zip,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[4,5]),'Comb'('ConsCall','.',['Comb'('ConsCall','(,)',['Var'(2),'Var'(4)]),'Comb'('FuncCall',zip,['Var'(3),'Var'(5)])]))]))]))).
evaluation(zip3,'Rule'([0,1,2],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[7,8]),'Comb'('ConsCall','.',['Comb'('ConsCall','(,,)',['Var'(3),'Var'(5),'Var'(7)]),'Comb'('FuncCall',zip3,['Var'(4),'Var'(6),'Var'(8)])]))]))]))]))).
evaluation(zipWith,'Rule'([0,1,2],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[5,6]),'Comb'('ConsCall','.',['Apply'('Apply'('Var'(0),'Var'(3)),'Var'(5)),'Comb'('FuncCall',zipWith,['Var'(0),'Var'(4),'Var'(6)])]))]))]))).
evaluation(zipWith3,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[4,5]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[6,7]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[8,9]),'Comb'('ConsCall','.',['Apply'('Apply'('Apply'('Var'(0),'Var'(4)),'Var'(6)),'Var'(8)),'Comb'('FuncCall',zipWith3,['Var'(0),'Var'(5),'Var'(7),'Var'(9)])]))]))]))]))).
evaluation(unzip,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[3,4]),'Comb'('FuncCall',prelude_lambda1_1962,['Var'(3),'Var'(4),'Comb'('FuncCall',unzip,['Var'(2)])]))]))]))).
evaluation(unzip3,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(1),['Branch'('Pattern'('(,,)',[3,4,5]),'Comb'('FuncCall',prelude_lambda2_1963,['Var'(3),'Var'(4),'Var'(5),'Comb'('FuncCall',unzip3,['Var'(2)])]))]))]))).
evaluation(concat,'Rule'([0],'Comb'('FuncCall',foldr,['Comb'('PartCall',++,[]),'Comb'('ConsCall',[],[]),'Var'(0)]))).
evaluation(concatMap,'Rule'([0,1],'Apply'('Comb'('FuncCall','$comp',['Comb'('PartCall',concat,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(iterate,'Rule'([0,1],'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',iterate,['Var'(0),'Apply'('Var'(0),'Var'(1))])]))).
evaluation(repeat,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',repeat,['Var'(0)])]))).
evaluation(replicate,'Rule'([0,1],'Comb'('FuncCall',take,['Var'(0),'Comb'('FuncCall',repeat,['Var'(1)])]))).
evaluation(take,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',takep_418,['Var'(0),'Var'(1)])]))).
evaluation(drop,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Var'(1),'Comb'('FuncCall',dropp_425,['Var'(0),'Var'(1)])]))).
evaluation(splitAt,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',<=,['Var'(0),'Lit'('Intc'(0))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(1)]),'Comb'('FuncCall',splitAtp_432,['Var'(0),'Var'(1)])]))).
evaluation(takeWhile,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',takeWhile,['Var'(0),'Var'(3)])]),'Comb'('ConsCall',[],[])]))]))).
evaluation(dropWhile,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',dropWhile,['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])]))]))).
evaluation(span,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',if_then_else,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',prelude_lambda4_1965,['Var'(2),'Comb'('FuncCall',span,['Var'(0),'Var'(3)])]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(2),'Var'(3)])])]))]))).
evaluation(break,'Rule'([0,1],'Apply'('Comb'('PartCall',span,['Comb'('FuncCall','$comp',['Comb'('PartCall',not,[]),'Var'(0)])]),'Var'(1)))).
evaluation(lines,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',prelude_lambda6_1967,['Comb'('FuncCall',splitline_456,['Comb'('ConsCall','.',['Var'(1),'Var'(2)])])]))]))).
evaluation(unlines,'Rule'([0],'Apply'('Comb'('FuncCall',concatMap,['Comb'('PartCall',prelude_lambda7_1968,[])]),'Var'(0)))).
evaluation(words,'Rule'([0],'Comb'('FuncCall',prelude_lambda8_1970,['Comb'('FuncCall',dropWhile,['Comb'('PartCall',isSpace_466,[]),'Var'(0)])]))).
evaluation(unwords,'Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',foldr1,['Comb'('PartCall',prelude_lambda10_1971,[]),'Var'(0)])]))).
evaluation(reverse,'Rule'([0],'Apply'('Comb'('PartCall',foldl,['Comb'('PartCall',flip,['Comb'('PartCall','.',[])]),'Comb'('ConsCall',[],[])]),'Var'(0)))).
evaluation(and,'Rule'([0],'Apply'('Comb'('PartCall',foldr,['Comb'('PartCall',&&,[]),'Comb'('ConsCall','True',[])]),'Var'(0)))).
evaluation(or,'Rule'([0],'Apply'('Comb'('PartCall',foldr,['Comb'('PartCall','||',[]),'Comb'('ConsCall','False',[])]),'Var'(0)))).
evaluation(any,'Rule'([0,1],'Apply'('Comb'('FuncCall','$comp',['Comb'('FuncCall',or,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(all,'Rule'([0,1],'Apply'('Comb'('FuncCall','$comp',['Comb'('FuncCall',and,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)))).
evaluation(elem,'Rule'([0,1],'Apply'('Comb'('FuncCall',any,['Comb'('PartCall',prelude_lambda11_1972,['Var'(0)])]),'Var'(1)))).
evaluation(notElem,'Rule'([0,1],'Apply'('Comb'('FuncCall',all,['Comb'('PartCall',prelude_lambda12_1973,['Var'(0)])]),'Var'(1)))).
evaluation(lookup,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','Nothing',[])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[4,5]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Var'(4)]),'Comb'('ConsCall','Just',['Var'(5)]),'Comb'('FuncCall',lookup,['Var'(0),'Var'(3)])]))]))]))).
evaluation(enumFrom,'Rule'([0],'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFrom,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))])])]))).
evaluation(enumFromThen,'Rule'([0,1],'Comb'('FuncCall',iterate,['Comb'('PartCall',prelude_lambda13_1974,['Var'(1),'Var'(0)]),'Var'(0)]))).
evaluation(enumFromTo,'Rule'([0,1],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>,['Var'(0),'Var'(1)]),'Comb'('ConsCall',[],[]),'Comb'('ConsCall','.',['Var'(0),'Comb'('FuncCall',enumFromTo,['Comb'('FuncCall',+,['Var'(0),'Lit'('Intc'(1))]),'Var'(1)])])]))).
evaluation(enumFromThenTo,'Rule'([0,1,2],'Comb'('FuncCall',takeWhile,['Comb'('PartCall',p_494,['Var'(1),'Var'(0),'Var'(2)]),'Comb'('FuncCall',enumFromThen,['Var'(0),'Var'(1)])]))).
evaluation(&>,'Rule'([0,1],'GuardedExpr'([],'Constr'([],'Var'(0)),'Var'(1)))).
evaluation(maybe,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Nothing',[]),'Var'(0)),'Branch'('Pattern'('Just',[3]),'Apply'('Var'(1),'Var'(3)))]))).
evaluation(either,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('Left',[3]),'Apply'('Var'(0),'Var'(3))),'Branch'('Pattern'('Right',[4]),'Apply'('Var'(1),'Var'(4)))]))).
evaluation(done,'Rule'([0],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','()',[])]),'Var'(0)))).
evaluation(putStr,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',done,[]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putChar,['Var'(1)]),'Comb'('FuncCall',putStr,['Var'(2)])]),'Var'(3)))]))).
evaluation(putStrLn,'Rule'([0,1],'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',putStr,['Var'(0)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]),'Var'(1)))).
evaluation(getLine,'Rule'([0],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall',getChar,[]),'Comb'('PartCall',lambdafun_1976,[])]),'Var'(0)))).
evaluation(print,'Rule'([0,1],'Apply'('Comb'('FuncCall',putStrLn,['Comb'('FuncCall',show,['Var'(0)])]),'Var'(1)))).
evaluation(doSolve,'Rule'([0,1],'GuardedExpr'([],'Constr'([],'Var'(0)),'Apply'('Comb'('FuncCall',done,[]),'Var'(1))))).
evaluation(sequenceIO,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>=,['Var'(1),'Comb'('PartCall',lambdafun_1979,['Var'(2)])]),'Var'(3)))]))).
evaluation(sequenceIO_,'Rule'([0,1],'Apply'('Apply'('Comb'('PartCall',foldr,['Comb'('PartCall',>>,[]),'Comb'('FuncCall',done,[])]),'Var'(0)),'Var'(1)))).
evaluation(mapIO,'Rule'([0,1,2],'Apply'('Apply'('Comb'('FuncCall','$comp',['Comb'('PartCall',sequenceIO,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)),'Var'(2)))).
evaluation(mapIO_,'Rule'([0,1,2],'Apply'('Apply'('Comb'('FuncCall','$comp',['Comb'('FuncCall',sequenceIO_,[]),'Comb'('PartCall',map,['Var'(0)])]),'Var'(1)),'Var'(2)))).
evaluation(inject,'Rule'([0,1,2],'Apply'('Comb'('PartCall',prelude_lambda15_1980,['Var'(1),'Var'(0)]),'Var'(2)))).
evaluation(solveAll,'Rule'([0],'Comb'('FuncCall',evalall_529,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(solveAll2,'Rule'([0],'Comb'('FuncCall',evalResult_546,['Comb'('FuncCall',try,['Var'(0)])]))).
evaluation(once,'Rule'([0,1],'Apply'('Comb'('FuncCall',head,['Comb'('FuncCall',solveAll,['Var'(0)])]),'Var'(1)))).
evaluation(one,'Rule'([0],'Comb'('FuncCall',solveAll,['Comb'('PartCall',prelude_lambda16_1981,['Var'(0)])]))).
evaluation(condSearch,'Rule'([0,1],'Comb'('FuncCall',one,['Comb'('PartCall',prelude_lambda17_1982,['Var'(0),'Var'(1)])]))).
evaluation(best,'Rule'([0,1],'Comb'('FuncCall',bestHelp_561,['Var'(1),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',try,['Var'(0)]),'Comb'('ConsCall',[],[])]))).
evaluation(browse,'Rule'([0,1],'Apply'('Comb'('FuncCall',putStr,['Comb'('FuncCall',show,['Comb'('FuncCall',unpack,['Var'(0)])])]),'Var'(1)))).
evaluation(browseList,'Rule'([0,3],'Case'('Rigid','Var'(0),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',done,[]),'Var'(3))),'Branch'('Pattern'('.',[1,2]),'Apply'('Comb'('FuncCall',>>,['Comb'('FuncCall',>>,['Comb'('FuncCall',browse,['Var'(1)]),'Comb'('FuncCall',putChar,['Lit'('Charc'(10))])]),'Comb'('FuncCall',browseList,['Var'(2)])]),'Var'(3)))]))).
evaluation(unpack,'Rule'([0],'GuardedExpr'([1],'Constr'([],'Apply'('Var'(0),'Var'(1))),'Var'(1)))).
evaluation('PEVAL','Rule'([0],'Var'(0))).
evaluation(prelude_lambda0_1961,'Rule'([0,1,2],'Apply'('Var'(0),'Apply'('Var'(1),'Var'(2))))).
evaluation(prelude_lambda1_1962,'Rule'([0,1,2],'Case'('Flex','Var'(2),['Branch'('Pattern'('(,)',[3,4]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(3)]),'Comb'('ConsCall','.',['Var'(1),'Var'(4)])]))]))).
evaluation(prelude_lambda2_1963,'Rule'([0,1,2,3],'Case'('Flex','Var'(3),['Branch'('Pattern'('(,,)',[4,5,6]),'Comb'('ConsCall','(,,)',['Comb'('ConsCall','.',['Var'(0),'Var'(4)]),'Comb'('ConsCall','.',['Var'(1),'Var'(5)]),'Comb'('ConsCall','.',['Var'(2),'Var'(6)])]))]))).
evaluation(takep_418,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',take,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(dropp_425,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',drop,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)]))]))).
evaluation(splitAtp_432,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[2,3]),'Comb'('FuncCall',prelude_lambda3_1964,['Var'(2),'Comb'('FuncCall',splitAt,['Comb'('FuncCall',-,['Var'(0),'Lit'('Intc'(1))]),'Var'(3)])]))]))).
evaluation(prelude_lambda3_1964,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda4_1965,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(splitline_456,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(1),'Lit'('Charc'(10))]),'Comb'('ConsCall','(,)',['Comb'('ConsCall',[],[]),'Var'(2)]),'Comb'('FuncCall',prelude_lambda5_1966,['Var'(1),'Comb'('FuncCall',splitline_456,['Var'(2)])])]))]))).
evaluation(prelude_lambda5_1966,'Rule'([0,1],'Case'('Flex','Var'(1),['Branch'('Pattern'('(,)',[2,3]),'Comb'('ConsCall','(,)',['Comb'('ConsCall','.',['Var'(0),'Var'(2)]),'Var'(3)]))]))).
evaluation(prelude_lambda6_1967,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',lines,['Var'(2)])]))]))).
evaluation(prelude_lambda7_1968,'Rule'([0],'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(10)),'Comb'('ConsCall',[],[])])]))).
evaluation(isSpace_466,'Rule'([0],'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(32))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(9))]),'Comb'('FuncCall','||',['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(13))])])])]))).
evaluation(prelude_lambda9_1969,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'('(,)',[1,2]),'Comb'('ConsCall','.',['Var'(1),'Comb'('FuncCall',words,['Var'(2)])]))]))).
evaluation(prelude_lambda8_1970,'Rule'([0],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Comb'('ConsCall',[],[])]),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',prelude_lambda9_1969,['Apply'('Comb'('FuncCall',break,['Comb'('PartCall',isSpace_466,[])]),'Var'(0))])]))).
evaluation(prelude_lambda10_1971,'Rule'([0,1],'Comb'('FuncCall',++,['Var'(0),'Comb'('ConsCall','.',['Lit'('Charc'(32)),'Var'(1)])]))).
evaluation(prelude_lambda11_1972,'Rule'([0,1],'Comb'('FuncCall',==,['Var'(0),'Var'(1)]))).
evaluation(prelude_lambda12_1973,'Rule'([0,1],'Comb'('FuncCall',/=,['Var'(0),'Var'(1)]))).
evaluation(prelude_lambda13_1974,'Rule'([0,1,2],'Comb'('FuncCall',+,['Comb'('FuncCall',-,['Var'(0),'Var'(1)]),'Var'(2)]))).
evaluation(p_494,'Rule'([0,1,2,3],'Comb'('FuncCall',if_then_else,['Comb'('FuncCall',>=,['Var'(0),'Var'(1)]),'Comb'('FuncCall',<=,['Var'(3),'Var'(2)]),'Comb'('FuncCall',>=,['Var'(3),'Var'(2)])]))).
evaluation(prelude_lambda14_1975,'Rule'([0,1,2],'Apply'('Var'(0),'Var'(2)))).
evaluation(lambdafun_1976,'Rule'([0,1],'Apply'('Comb'('FuncCall',if_then_else,['Comb'('FuncCall',==,['Var'(0),'Lit'('Charc'(10))]),'Comb'('FuncCall',return,['Comb'('ConsCall',[],[])]),'Comb'('FuncCall',>>=,['Comb'('FuncCall',getLine,[]),'Comb'('PartCall',lambdafun_1977,['Var'(0)])])]),'Var'(1)))).
evaluation(lambdafun_1977,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]),'Var'(2)))).
evaluation(lambdafun_1978,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',return,['Comb'('ConsCall','.',['Var'(0),'Var'(1)])]),'Var'(2)))).
evaluation(lambdafun_1979,'Rule'([0,1,2],'Apply'('Comb'('FuncCall',>>=,['Comb'('FuncCall',sequenceIO,['Var'(0)]),'Comb'('PartCall',lambdafun_1978,['Var'(1)])]),'Var'(2)))).
evaluation(prelude_lambda15_1980,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Apply'('Var'(1),'Var'(2))]))).
evaluation(evalall_529,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[3,4]),'Comb'('FuncCall',evalall3_531,['Comb'('FuncCall',try,['Var'(1)]),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])]))]))]))).
evaluation(evalall2_530,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Comb'('FuncCall',evalall3_531,['Comb'('FuncCall',try,['Var'(1)]),'Var'(2)]))]))).
evaluation(evalall3_531,'Rule'([0,1],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('FuncCall',evalall2_530,['Var'(1)])),'Branch'('Pattern'('.',[2,3]),'Case'('Flex','Var'(3),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(2),'Comb'('FuncCall',evalall2_530,['Var'(1)])])),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',evalall3_531,['Comb'('FuncCall',try,['Var'(2)]),'Comb'('ConsCall','.',['Var'(4),'Comb'('FuncCall',++,['Var'(5),'Var'(1)])])]))]))]))).
evaluation(evalResult_546,'Rule'([0],'Case'('Flex','Var'(0),['Branch'('Pattern'([],[]),'Comb'('ConsCall',[],[])),'Branch'('Pattern'('.',[1,2]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall',[],[])])),'Branch'('Pattern'('.',[3,4]),'Apply'('Comb'('FuncCall',concatMap,['Comb'('PartCall',solveAll2,[])]),'Comb'('ConsCall','.',['Var'(1),'Comb'('ConsCall','.',['Var'(3),'Var'(4)])])))]))]))).
evaluation(prelude_lambda16_1981,'Rule'([0,1],'Comb'('FuncCall',=:=,['Var'(1),'Comb'('FuncCall',tryone,['Var'(0)])]))).
evaluation(prelude_lambda17_1982,'Rule'([0,1,2],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(2)),'Comb'('FuncCall',=:=,['Apply'('Var'(1),'Var'(2)),'Comb'('ConsCall','True',[])])]))).
evaluation(bestHelp_561,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Var'(3)),'Branch'('Pattern'('.',[4,5]),'Comb'('FuncCall',evalB_562,['Var'(0),'Comb'('FuncCall',try,['Comb'('FuncCall',constrain_564,['Var'(0),'Var'(4),'Var'(3)])]),'Var'(5),'Var'(3)]))])),'Branch'('Pattern'('.',[6,7]),'Comb'('FuncCall',evalA_563,['Var'(0),'Comb'('FuncCall',try,['Var'(6)]),'Var'(7),'Var'(2),'Var'(3)]))]))).
evaluation(evalB_562,'Rule'([0,1,2,3],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Comb'('ConsCall',[],[]),'Var'(2),'Var'(3)])),'Branch'('Pattern'('.',[4,5]),'Case'('Flex','Var'(5),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Comb'('ConsCall',[],[]),'Var'(2),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall',[],[])])])),'Branch'('Pattern'('.',[6,7]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Comb'('ConsCall','.',['Var'(4),'Comb'('ConsCall','.',['Var'(6),'Var'(7)])]),'Var'(2),'Var'(3)]))]))]))).
evaluation(evalA_563,'Rule'([0,1,2,3,4],'Case'('Flex','Var'(1),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Var'(2),'Var'(3),'Var'(4)])),'Branch'('Pattern'('.',[5,6]),'Case'('Flex','Var'(6),['Branch'('Pattern'([],[]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Comb'('ConsCall',[],[]),'Comb'('FuncCall',++,['Var'(2),'Var'(3)]),'Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall',[],[])])])),'Branch'('Pattern'('.',[7,8]),'Comb'('FuncCall',bestHelp_561,['Var'(0),'Comb'('FuncCall',++,['Comb'('ConsCall','.',['Var'(5),'Comb'('ConsCall','.',['Var'(7),'Var'(8)])]),'Var'(2)]),'Var'(3),'Var'(4)]))]))]))).
evaluation(constrain_564,'Rule'([0,1,2,5],'Case'('Flex','Var'(2),['Branch'('Pattern'([],[]),'Apply'('Var'(1),'Var'(5))),'Branch'('Pattern'('.',[3,4]),'Case'('Flex','Var'(4),['Branch'('Pattern'([],[]),'Apply'('Comb'('FuncCall',inject,['Var'(1),'Comb'('PartCall',prelude_lambda18_1983,['Var'(3),'Var'(0)])]),'Var'(5)))]))]))).
evaluation(prelude_lambda18_1983,'Rule'([0,1,2],'Constr'([3],'Comb'('FuncCall',&,['Apply'('Var'(0),'Var'(3)),'Comb'('FuncCall',=:=,['Apply'('Apply'('Var'(1),'Var'(2)),'Var'(3)),'Comb'('ConsCall','True',[])])])))).




%%%%% Number of shared variables: 51
